*********************************************************************
      module createfile
*********************************************************************
      implicit none
      contains
!----------------------------------------------------------------------
      subroutine CREATEphitsinp(iorg,iparam,ixnum,iynum,iznum,
     &     xdel,ydel,zdel,xorg,yorg,zorg,xsh,xvec,yvec,zvec,
     &     Cinput)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: iorg,iparam
      integer,intent(in) :: ixnum,iynum,iznum
      real(8),intent(in) :: xdel,ydel,zdel,xorg,yorg,zorg
      real(8),intent(in) :: xsh(3),xvec(3),yvec(3),zvec(3)
      character(LEN=200),intent(in) :: Cinput
      integer :: io
      integer :: Ninput

      io=30
      Ninput=len_trim(Cinput)
      open(io,file=Cinput(1:Ninput)//'phits.inp',status='unknown')
      write(io,'(2a)')' file = phits.inp'
      write(io,'(a)')
      write(io,'(a)')'[ Title ]'
      write(io,'(a)')
     &     'Voxel phantom automatically generated by dicom2phits'
      write(io,'(a)')
      write(io,'(a)')'[ Parameters ]'
      call CREATEparam(io,iparam,Cinput)
      write(io,'(a)')
      call CREATEusrparam(io,iorg,ixnum,iynum,iznum,
     &     xdel,ydel,zdel,xorg,yorg,zorg)
      write(io,'(a)')
      write(io,'(a)')'[ Transform ]'
      call CREATEtrans(io,iorg,ixnum,iynum,iznum,
     &     xsh,xvec,yvec,zvec,xdel,ydel,zdel,xorg,yorg,zorg)
      write(io,'(a)')
      write(io,'(a)')'[ Source ]'
      call CREATEsource(io,iparam)
      write(io,'(a)')
      write(io,'(a)')'[ Surface ]'
      call CREATEsurf(io)
      write(io,'(a)')
      write(io,'(a)')'[ Cell ]'
      call CREATEcell(io,ixnum,iynum,iznum,Cinput)
      write(io,'(a)')
      write(io,'(a)')'[ Material ]'
      call CREATEmat(io,Cinput)
      write(io,'(a)')
      write(io,'(a)')'[ T-3Dshow ]'
      call CREATEt3Dshow(io,iorg,ixnum,iynum,iznum,xdel,ydel,zdel,xsh)
      write(io,'(a)')
      if(iorg.eq.-1)then
       write(io,'(a)')'[ T-Deposit ] off'
      else
       write(io,'(a)')'[ T-Deposit ]'
      endif
      call CREATEtdeposit(io,iorg,ixnum,iynum,iznum,xdel,ydel,zdel,xsh,
     &     'xy')
      write(io,'(a)')
      if(iorg.eq.-1)then
       write(io,'(a)')'[ T-Deposit ] off'
      else
       write(io,'(a)')'[ T-Deposit ]'
      endif
      call CREATEtdeposit(io,iorg,ixnum,iynum,iznum,xdel,ydel,zdel,xsh,
     &     'xz')
c$$$      write(io,'(a)')
c$$$      write(io,'(a)')'[ T-Track ]'
c$$$      call CREATEttrack(io,iorg,ixnum,iynum,iznum,xdel,ydel,zdel,xsh,
c$$$     &     'xy')
      if(iorg.eq.1.or.iorg.eq.-1)then
       write(io,'(a)')
       if(iorg.eq.1)then
        write(io,'(a)')'[ T-Deposit ] off'
       else
        write(io,'(a)')'[ T-Deposit ]'
       endif
       call CREATEt3Ddeposit(io,ixnum,iynum,iznum,xsh,xdel,ydel,zdel)
      endif
      write(io,'(a)')
      write(io,'(a)')'[ End ]'
      close(io)
      return
      end subroutine CREATEphitsinp
!----------------------------------------------------------------------
      subroutine CREATEparam(io,iparam,Cinput)
!----------------------------------------------------------------------
      use stdinout, only:stdout
      implicit none
      integer,intent(in) :: io,iparam
      character(LEN=200),intent(in) :: Cinput
      integer Ninput
      logical Fex

      write(io,'(2a)')' icntl    =           0     ',
     &     '# (D=0) 3:ECH 5:NOR 6:SRC 7,8:GSH 11:DSH 12:DUMP'
      write(io,'(2a)')' maxcas   =       10000     ',
     &     '# (D=10) number of particles per one batch'
      write(io,'(2a)')' maxbch   =           2     ',
     &     '# (D=10) number of batches'
      write(io,'(2a)')' file(6)  = phits.out       ',
     &     '# (D=phits.out) general output file name'
      write(io,'(a)')'$   ivoxel = 2'
      write(io,'(a)')' file(18) = voxel.bin'
      write(io,'(a)')'$   ipegs = -1'
      write(io, '(a)')

      if(iparam.eq.1)then
        write(io,'(a)')'$ Optimized for Photon Therapy'
        write(io,'(2a)')' emin(2)  = 1.000000000E-10 ',
     &       '# (D=1.0) cut-off energy of neutron (MeV)'
        write(io,'(2a)')' dmax(2)  =  20.0000000     ',
     &       '# (D=emin(2)) data max. energy of neutron (MeV)'
        write(io,'(2a)')' emin(12) = 1.000000000E-01 ',
     &       '# (D=1.d9) cut-off energy of electron (MeV)'
        write(io,'(2a)')' emin(13) = 1.000000000E-01 ',
     &       '# (D=1.d9) cut-off energy of positron (MeV)'
        write(io,'(2a)')' emin(14) = 1.000000000E-03 ',
     &       '# (D=1.d9) cut-off energy of photon (MeV)'
        write(io,'(2a)')' dmax(12) =  1000.00000     ',
     &       '# (D=emin(12)) data max. energy of electron (MeV)'
        write(io,'(2a)')' dmax(13) =  1000.00000     ',
     &       '# (D=emin(13)) data max. energy of positron (MeV)'
        write(io,'(2a)')' dmax(14) =  1000.00000     ',
     &       '# (D=emin(14)) data max. energy of photon (MeV)'
        write(io,'(2a)')' igamma   =           2     ',
     &       '# (D=0) 0:No, 1:Old, 2:EBITEM, 3:EBITEM+Isomer'
        write(io,'(2a)')' ipnint   =           1     ',
     &       '# (D=0) 0: no, 1: consider photo-nuclear reaction'
        write(io,'(2a)')' negs     =           1     ',
     &       '# (D=0) =1 EGS photon and electron'
      elseif(iparam.eq.2)then
        write(io,'(a)')'$ Optimized for Particle Therapy'
        write(io,'(2a)')' emin(2)  = 1.000000000E-10 ',
     &       '# (D=1.0) cut-off energy of neutron (MeV)'
        write(io,'(2a)')' dmax(2)  =  20.0000000     ',
     &       '# (D=emin(2)) data max. energy of neutron (MeV)'
        write(io,'(2a)')' emin(12) = 1.000000000E-01 ',
     &       '# (D=1.d9) cut-off energy of electron (MeV)'
        write(io,'(2a)')' emin(13) = 1.000000000E-01 ',
     &       '# (D=1.d9) cut-off energy of positron (MeV)'
        write(io,'(2a)')' emin(14) = 1.000000000E-03 ',
     &       '# (D=1.d9) cut-off energy of photon (MeV)'
        write(io,'(2a)')' dmax(12) =  1000.00000     ',
     &       '# (D=emin(12)) data max. energy of electron (MeV)'
        write(io,'(2a)')' dmax(13) =  1000.00000     ',
     &       '# (D=emin(13)) data max. energy of positron (MeV)'
        write(io,'(2a)')' dmax(14) =  1000.00000     ',
     &       '# (D=emin(14)) data max. energy of photon (MeV)'
        write(io,'(2a)')' e-mode   =           2     ',
     &       '# (D=0) 0: Normal, 1: Event generator mode'
        write(io,'(2a)')' irqmd    =           1     ',
     &       '# (D=0) 0: JQMD legacy version, 1: R-JQMD'
        write(io,'(2a)')' nedisp   =           1     ',
     &       '# (D=0) 0: no, 1: with e straggling, 10: ATIMA'
        write(io,'(2a)')' nspred   =           2     ',
     &       '# (D=0) 0:no, 1:orig. 2:Lynch(Moliere), 10: ATIMA'
        write(io,'(2a)')' ascat1   =  13.6000000     ',
     &       '# (D=13.6) S2 parameter in Lynch formula for nspread = 2'
        write(io,'(2a)')' ascat2   = 8.800000000E-02 ',
     &       '# (D=0.088) e parameter in Lynch formula for nspread = 2'
        write(io,'(2a)')' negs     =           1     ',
     &       '# (D=0) =1 EGS photon and electron'
      endif
      write(io,'(a)')'$ Library data paths for file(7) & file(20)'
      write(io,'(a)')' infl:{libpath.inp}'
      Ninput=len_trim(Cinput)
      inquire(file=Cinput(1:Ninput)//'libpath.inp',exist=Fex)
      if(.not.Fex)then
       write(stdout,'(2a)')'Warning: libpath.inp dose not exist',
     &      ' and thus newly created'
       write(stdout,'(2a)')
     &      '**************************************************',
     &      '*******************'
       open(20,file=Cinput(1:Ninput)//'libpath.inp',status='new')
       write(20,'(2a)')' file(7)  = c:/phits/data/xsdir.jnd ',
     &      '# (D=xdirs) nuclear data input file name'
       write(20,'(2a)')' file(20) = c:/phits/XS/egs ',
     &      '# (D=/phits/XS/egs) EGS data folder name'
       close(20)
      endif

      return
      end subroutine CREATEparam
!----------------------------------------------------------------------
      subroutine CREATEusrparam(io,iorg,ixnum,iynum,iznum,
     &     xdel,ydel,zdel,xorg,yorg,zorg)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io,iorg
      integer,intent(in) :: ixnum,iynum,iznum
      real(8),intent(in) :: xdel,ydel,zdel,xorg,yorg,zorg
      real(8) :: epsilon=1.0d-5

      write(io,'(a)')'$ parameters'
      write(io,5000)'set: c',81,'[',ixnum,']  $ number of x pixel'
      write(io,5000)'set: c',82,'[',iynum,']  $ number of y pixel'
      write(io,5000)'set: c',83,'[',iznum,']  $ number of z pixel'
      write(io,5001)'set: c',84,'[',xdel,'] $ unit voxel x'
      write(io,5001)'set: c',85,'[',ydel,'] $ unit voxel y'
      write(io,5001)'set: c',86,'[',zdel,'] $ unit voxel z'
      if(iorg.eq.0)then
        write(io,5001)'set: c',87,'[-c81*c84/2] $ smallest x'
        write(io,5001)'set: c',88,'[-c82*c85/2] $ smallest y'
        write(io,5001)'set: c',89,'[-c83*c86/2] $ smallest z'
      else
        write(io,5001)'set: c',87,'[',xorg,
     &       '] $ smallest x'
        write(io,5001)'set: c',88,'[',yorg,
     &       '] $ smallest y'
        write(io,5001)'set: c',89,'[',zorg,
     &       '] $ smallest z'
      endif
      write(io,5001)'set: c',90,'[',epsilon,'] $ small quota' 
 5000 format(a,i2,a,i5,a)
 5001 format(a,i2,a,f12.5,a)

      return
      end subroutine CREATEusrparam
!----------------------------------------------------------------------
      subroutine CREATEsource(io,iparam)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io,iparam
      if(iparam.eq.2)then
       write(io,5000)' s-type = 1',
     &      ' $ Cylindrical source with mono-energy'
      else
       write(io,5000)' s-type = 4',
     &      ' $ cylindrical source with energy spectrum'
      endif
      write(io,5000)'$ Create radiation field centered on 0'
      write(io,5000)'$ Adjust center of radiation field in trcl=400'
      write(io,5000)'     x0 =  0.0'
      write(io,5000)'     y0 =  0.0'
      write(io,5000)'     z0 =  0.0'
      write(io,5000)'     z1 =  0.0'
      write(io,5000)'     r0 =  5.0'
      write(io,5000)'    dir =  1.0'
      write(io,5000)'   trcl =  400'
      if(iparam.eq.1)then
       write(io,5000)'   proj =  photon'
      else
       write(io,5000)'   proj =  proton'
      endif
      if(iparam.eq.2)then
       write(io,5000)'     e0 = 100.0'
      else
       call CREATEspectrum(io,iparam)
      endif
 5000 format(2a)
      return
      end subroutine CREATEsource
!----------------------------------------------------------------------
      subroutine CREATEspectrum(io,iparam)
!----------------------------------------------------------------------
      integer,intent(in) :: io,iparam
      integer :: i
      real(8) :: xdata1(24+1),ydata1(24)
      data xdata1/
     &     0.00, 0.25, 0.50, 0.75, 1.00, 1.25, 1.50, 1.75, 2.00, 2.25,
     &     2.50, 2.75, 3.00, 3.25, 3.50, 3.75, 4.00, 4.25, 4.50, 4.75,
     &     5.00, 5.25, 5.50, 5.75, 6.00/
      data ydata1/
     &     2.14E-03, 1.26E-02, 1.31E-02, 1.14E-02, 9.76E-03, 8.36E-03,
     &     7.25E-03, 6.23E-03, 5.35E-03, 4.59E-03, 3.95E-03, 3.47E-03,
     &     2.98E-03, 2.61E-03, 2.25E-03, 1.91E-03, 1.66E-03, 1.38E-03,
     &     1.14E-03, 9.04E-04, 6.55E-04, 4.09E-04, 1.40E-04, 4.34E-06/
      real(8) :: xdata2(50+1),ydata2(50)
      data xdata2/
     &     4.0000E+01, 4.1308E+01, 4.2660E+01, 4.4055E+01, 4.5496E+01,
     &     4.6985E+01, 4.8522E+01, 5.0109E+01, 5.1748E+01, 5.3441E+01,
     &     5.5189E+01, 5.6995E+01, 5.8859E+01, 6.0784E+01, 6.2773E+01,
     &     6.4826E+01, 6.6947E+01, 6.9137E+01, 7.1399E+01, 7.3734E+01,
     &     7.6146E+01, 7.8637E+01, 8.1209E+01, 8.3866E+01, 8.6610E+01,
     &     8.9443E+01, 9.2369E+01, 9.5390E+01, 9.8511E+01, 1.0173E+02,
     &     1.0506E+02, 1.0850E+02, 1.1205E+02, 1.1571E+02, 1.1950E+02,
     &     1.2341E+02, 1.2744E+02, 1.3161E+02, 1.3592E+02, 1.4036E+02,
     &     1.4496E+02, 1.4970E+02, 1.5459E+02, 1.5965E+02, 1.6487E+02,
     &     1.7027E+02, 1.7584E+02, 1.8159E+02, 1.8753E+02, 1.9366E+02,
     &     2.0000E+02/
      data ydata2/
     &     5.9392E-08, 8.6861E-08, 1.2391E-07, 1.5097E-07, 2.3012E-07,
     &     2.8258E-07, 3.5983E-07, 4.6746E-07, 4.8658E-07, 5.3200E-07,
     &     5.3491E-07, 5.1361E-07, 5.4590E-07, 6.5433E-07, 6.4065E-07,
     &     6.5380E-07, 7.2502E-07, 7.8546E-07, 8.3408E-07, 8.3855E-07,
     &     9.5379E-07, 9.6643E-07, 1.0838E-06, 1.1017E-06, 1.2548E-06,
     &     1.3560E-06, 1.5153E-06, 1.6931E-06, 1.9950E-06, 2.3295E-06,
     &     2.9149E-06, 3.7890E-06, 7.2676E-06, 8.3105E-06, 5.3924E-07,
     &     2.2914E-08, 2.2236E-08, 2.4404E-08, 2.1930E-08, 3.9245E-08,
     &     5.1149E-08, 5.1052E-10, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     &     0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/

      if(iparam.eq.1)then
       write(io,5000)'$ Varian 6MV photon spectrum based on ',
     &      'D. Sheikh-Bagheri et al. PMB 29 (2002) 391'
       write(io,5000)' e-type = 1'
       write(io,5000)'     ne = 24'
       do i=1,24
        write(io,5010)xdata1(i),ydata1(i)
       enddo
       write(io,5010)xdata1(24+1)
      elseif(iparam.eq.3)then
       write(io,5000)'$ 190MeV proton SOBP spectrum'
       write(io,5000)' e-type = 21'
       write(io,5000)'     ne = 50'
       do i=1,50
        write(io,5010)xdata2(i),ydata2(i)
       enddo        
       write(io,5010)xdata2(50+1)
      endif
 5000 format(2a)
 5010 format(2(1X,1PE10.4e2))
      return
      end subroutine CREATEspectrum
!----------------------------------------------------------------------
      subroutine CREATEtrans(io,iorg,ixnum,iynum,iznum,
     &     xsh,xvec,yvec,zvec,xdel,ydel,zdel,xorg,yorg,zorg)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io,iorg,ixnum,iynum,iznum
      real(8),intent(in) :: xsh(3),xvec(3),yvec(3),zvec(3)
      real(8),intent(in) :: xdel,ydel,zdel,xorg,yorg,zorg
      real(8) :: x(3)
      integer i
      character(5) :: TAB='     '
      if(iorg.eq.0)then
       x(1)=0.0d0
       x(2)=-0.5d0*ydel*(iynum+1)
       x(3)=0.0d0
      else
       x(1)=xsh(1)+xorg+0.5d0*xdel*ixnum
       x(2)=xsh(2)+yorg-0.5d0*ydel
       x(3)=xsh(3)+zorg+0.5d0*zdel*iznum
      endif
      write(io,'(2a)')'$ ',
     &     'Transform source directing beam along x-axis'
      write(io,'(a,3f12.5,a)')'tr400 ',(x(i),i=1,3),
     &     ' $ Center of radiation field'
      write(io,'(a,3f10.5)')TAB,1.0d0,0.0d0,0.0d0
      write(io,'(a,3f10.5)')TAB,0.0d0,0.0d0,-1.0d0
      write(io,'(a,3f10.5)')TAB,0.0d0,1.0d0,0.0d0
      write(io,'(2a)')TAB,'1'

      if(iorg.eq.0)then
       write(io,'(a)')'$ Transform voxel phatom'
       write(io,'(a)')'set: c71[0]   $ angle of around Z (degree)'
       write(io,'(a)')'set: c72[0]   $ angle of around Y (degree)'
       write(io,'(a)')'set: c73[0]   $ angle of around X (degree)'
       write(io,'(a)')'set: c74[0]   $ displacement of Z (cm)'
       write(io,'(a)')'set: c75[0]   $ displacement of Y (cm)'
       write(io,'(a)')'set: c76[0]   $ displacement of X (cm)'
       write(io,'(a)')'tr500 c76 c75 c74'
       write(io,'(2a)')TAB,'cos(c71/180*pi)*cos(c72/180*pi)'
       write(io,'(3a)')TAB,'sin(c71/180*pi)*cos(c73/180*pi)',
     &      '+cos(c71/180*pi)*sin(c72/180*pi)*sin(c73/180*pi)'
       write(io,'(3a)')TAB,'sin(c71/180*pi)*sin(c73/180*pi)',
     &      '-cos(c71/180*pi)*sin(c72/180*pi)*cos(c73/180*pi)'
       write(io,'(2a)')TAB,' -sin(c71/180*pi)*cos(c72/180*pi)'
       write(io,'(3a)')TAB,'cos(c71/180*pi)*cos(c73/180*pi)',
     &      '-sin(c71/180*pi)*sin(c72/180*pi)*sin(c73/180*pi)'
       write(io,'(3a)')TAB,'cos(c71/180*pi)*sin(c73/180*pi)',
     &      '+sin(c71/180*pi)*sin(c72/180*pi)*cos(c73/180*pi)'
       write(io,'(2a)')TAB,'sin(c72/180*pi)'
       write(io,'(2a)')TAB,'-cos(c72/180*pi)*sin(c73/180*pi)'
       write(io,'(2a)')TAB,'cos(c72/180*pi)*cos(c73/180*pi)'
       write(io,'(2a)')TAB,'1'
      else
       write(io,'(2a)')'$ ',
     &      'Transform system according to DICOM header'
       write(io,'(a,3f12.5)')'tr500 ',(xsh(i),i=1,3)
       do i=1,3
        write(io,'(a,3f10.5)')TAB,xvec(i),yvec(i),zvec(i)
       enddo
       write(io,'(2a)')TAB,'1'
      endif
      return
      end subroutine CREATEtrans
!----------------------------------------------------------------------
      subroutine CREATEsurf(io)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io

      write(io,'(a)')'$ Unit voxel at smallest x & y'
      write(io,5003)' ',5000,' rpp',
     &     ' c87 c87+c84 c88 c88+c85 c89 c89+c86'
      write(io,'(a)')'$ Outer region'
      write(io,5002)' ',99,' so 500'
      write(io,'(a)')'$ Main Space'
      write(io,5003)' ',97,' rpp',
     &     ' c87+c90 c87+c81*c84-c90 c88+c90 c88+c82*c85-c90',
     &     ' c89+c90 c89+c83*c86-c90'
      write(io,5003)' ',98,' 500 rpp',
     &     ' c87+c90 c87+c81*c84-c90 c88+c90 c88+c82*c85-c90',
     &     ' c89+c90 c89+c83*c86-c90'
 5002 format(a,i4,a)
 5003 format(a,i4,4a)
      return
      end subroutine CREATEsurf
!----------------------------------------------------------------------
      subroutine CREATEcell(io,ixnum,iynum,iznum,Cinput)
!----------------------------------------------------------------------
      use readtable, only:Nuniv,rho
      implicit none
      integer,intent(in) :: io
      integer,intent(in) :: ixnum,iynum,iznum
      character(LEN=200),intent(in) :: Cinput
      integer :: iuniv
      integer :: Ninput

      Ninput=len_trim(Cinput)
      write(io,'(a)')'$ Material universe'
      write(io,'(a)')' infl:{universe.inp}'
      open(20,file=Cinput(1:Ninput)//'universe.inp',status='unknown')
      do iuniv=1,Nuniv
        write(20,5002)' ',5000+iuniv,' ',5000+iuniv,
     &       ' ',rho(iuniv),' -99 u=',5000+iuniv
      enddo
      close(20)
      write(io,'(a)')'$ Voxel universe'
      write(io,5000)' ',5000,' 0 -5000 lat=1 u=5000'
      write(io,5001)
     &     '      fill= 0:',ixnum-1,' 0:',iynum-1,' 0:',iznum-1
      write(io,'(a)')' infl:{voxel.inp}'
      write(io,'(a)')
     &     '$ The above line should be commented out when ivoxel=1'
      write(io,'(a)')'$ Main space'
      write(io,5000)' ',97,'  0   -97 trcl=500 fill=5000',
     &     ' $ Region filled with voxel phantom'
      write(io,5000)' ',98,'  0   -99 98',
     &     '                 $ Void'      
      write(io,5000)' ',99,' -1    99',
     &     '                    $ Outer region'

 5000 format(a,i4,2a)
 5001 format(a,i4,a,i4,a,i4)
 5002 format(2(a,i4),a,f12.5,a,i4)

      return
      end subroutine CREATEcell
!----------------------------------------------------------------------
      subroutine CREATEfill(ixnum,iynum,iznum,mat,Cinput)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: ixnum,iynum,iznum
      integer,intent(in) :: mat(ixnum,iynum,iznum)
      character(LEN=200),intent(in) :: Cinput
      integer ix,iy,iz,i,ii
      integer Ninput

      Ninput=len_trim(Cinput)
      open(20,file=Cinput(1:Ninput)//'voxel.inp',status='unknown')
      do iz=1,iznum
        do iy=1,iynum
          do i=1,ixnum,10
            ii=min(i+9,ixnum)
            write(20,'(6x,10(x,I4))'),(mat(ix,iy,iz),ix=i,ii)
          enddo
        enddo
      enddo
      close(20)
      return
      end subroutine CREATEfill
!----------------------------------------------------------------------
      subroutine CREATEmat(io,Cinput)
!----------------------------------------------------------------------
      use readtable, only:Nuniv,Nelement,Ncomm,Clines,Ccomment,CTthld
      implicit none
      integer,intent(in) :: io
      character(LEN=200),intent(in) :: Cinput
      integer :: iline,iuniv,i,iend
      character(6) :: TAB='      '
      integer Ninput
      integer,parameter :: iot=20

      Ninput=len_trim(Cinput)
      write(io,'(a)')
      write(io,'(a)')'$ Additional material should be defined above'
      write(io,'(a)')' infl:{material.inp}'
      write(io,'(a)')'$ Additional mat color should be defined below'

      open(iot,file=Cinput(1:Ninput)//'material.inp',status='unknown')
      write(iot,'(2a)'),'$ ',Ccomment(1:Ncomm)
      iline=0
      do iuniv=1,Nuniv
        if(iuniv.eq.1)then
          write(iot,'(a,i4,2a,f5.0)')'MAT[',5000+iuniv,'] ! ',
     &         ' CT number < ',CTthld(iuniv+1)
        elseif(iuniv.eq.Nuniv)then
          write(iot,'(a,i4,a,f5.0,a)')'MAT[',5000+iuniv,'] ! ',
     &         CTthld(iuniv), ' <= CT number'
        else
          write(iot,'(a,i4,a,f5.0,a,f5.0)')'MAT[',5000+iuniv,'] ! ',
     &         CTthld(iuniv), ' <= CT number < ',CTthld(iuniv+1)
        endif
        do i=1,Nelement(iuniv)
          iline=iline+1
          iend=len_trim(Clines(iline))
          write(iot,'(2a)')TAB,Clines(iline)(1:iend)
        enddo
      enddo
      write(iot,'(a)')
      write(iot,'(a)')'[ Mat Name Color ]'
      call CREATEcolor(iot)
      close(20)
      return
      end subroutine CREATEmat
!----------------------------------------------------------------------
      subroutine CREATEcolor(io)
!----------------------------------------------------------------------
      use readtable, only: Nuniv
      implicit none
      integer,intent(in) :: io
      integer :: iuniv
      write(io,'(a)')' mat   name   color'
      do iuniv=1,Nuniv
         write(io,5000)5000+iuniv,iuniv,-(iuniv-1)/dble(Nuniv-1)
 5000    format(' ',2(i4,' '),'{',f6.3,'}')
      enddo
      return
      end subroutine CREATEcolor
!----------------------------------------------------------------------
      subroutine CREATEt3Dshow(io,iorg,ixnum,iynum,iznum,
     &     xdel,ydel,zdel,xsh)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io,iorg
      integer,intent(in) :: ixnum,iynum,iznum
      real(8),intent(in) :: xdel,ydel,zdel,xsh(3)
      real(8) :: whgt
      real(8) :: wwdt

      wwdt=1.2d0*ixnum*xdel
      whgt=sqrt(iznum*iznum*zdel*zdel+iynum*iynum*ydel*ydel)
      whgt=1.2d0*whgt
      wwdt=max(wwdt,0.5d0*whgt)
      whgt=max(whgt,0.5d0*wwdt)
      write(io,5000)'   title  = [t-3dshow: icntl=11]'
      write(io,5000)'   file   = CT3D.out'
      if(iorg.eq.0)then
        write(io,5001)'       x0 = ',0.0d0
        write(io,5001)'       y0 = ',0.0d0
        write(io,5001)'       z0 = ',0.0d0
      else
        write(io,5002)'       x0 = c87+c81*c84/2+(',xsh(1),')'
        write(io,5002)'       y0 = c88+c82*c85/2+(',xsh(2),')'
        write(io,5002)'       z0 = c89+c83*c86/2+(',xsh(3),')'
      endif        
      write(io,5000)'    e-the =  60.0000'
      write(io,5000)'    e-phi =  290.00000'
      write(io,5000)'    l-the =  40.0000'
      write(io,5000)'    l-phi =  310.00000'
      write(io,5001)'    w-wdt = ',1.2d0*ixnum*xdel
      write(io,5001)'    w-hgt = ',whgt
      write(io,5001)'    w-dst = ',3.0d0*whgt
      write(io,5000)'   heaven =   z'
      write(io,5000)'    resol =   1'
      write(io,5000)'   shadow =   1'
      write(io,5000)'   epsout =   1'
      write(io,5000)' material =  -1'
      write(io,5000)'             5001'
 5000 format(a)
 5001 format(a,f12.5)
 5002 format(a,f12.5,a)
      return
      end subroutine CREATEt3Dshow
!----------------------------------------------------------------------
      subroutine CREATEttrack(io,iorg,
     &     ixnum,iynum,iznum,xdel,ydel,zdel,xsh,tag)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io,iorg
      integer,intent(in) :: ixnum,iynum,iznum
      real(8),intent(in) :: xdel,ydel,zdel
      real(8),intent(in) :: xsh(3)
      character(2),intent(in) :: tag
      real(8) :: xdist,ydist,zdist

      xdist=xdel*ixnum
      ydist=ydel*iynum
      zdist=zdel*iznum
      if(tag.eq.'xy')then
       xdist=max(xdist,0.5d0*ydist)
       ydist=max(ydist,0.5d0*xdist)
      elseif(tag.eq.'yz')then
       zdist=max(zdist,0.5d0*ydist)
       ydist=max(ydist,0.5d0*zdist)
      elseif(tag.eq.'xz')then
       zdist=max(zdist,0.5d0*xdist)
       xdist=max(xdist,0.5d0*zdist)
      else
       write(*,*)'ERROR: tag should be xy or yz or xz'
      endif
      write(io,5000)' title  = [t-track: icntl=0]'
      write(io,5003)' file   = track-',tag,'.out'
      write(io,5000)' mesh   = xyz'
      write(io,5000)' x-type = 2'
      if(tag.eq.'xy'.or.tag.eq.'xz')then
       write(io,5002)' nx     = ',ixnum
       if(iorg.eq.0)then
        write(io,5001)' xmin   = ',-0.5d0*xdist
        write(io,5001)' xmax   = ', 0.5d0*xdist
       else
        write(io,5001)' xmin   = c87+',0.5d0*(xdel*ixnum-xdist)+xsh(1)
        write(io,5001)' xmax   = c87+',0.5d0*(xdel*ixnum+xdist)+xsh(1)
       endif          
      elseif(tag.eq.'yz')then
       write(io,5002)' nx     = ',1
       if(iorg.eq.0)then
        if(mod(ixnum,2).eq.1)then
         write(io,5001)' xmin   = ',-xdel/2.0d0
         write(io,5001)' xmax   = ', xdel/2.0d0
        else
         write(io,5001)' xmin   = ',0.0d0
         write(io,5001)' xmax   = ',xdel
        endif
       else
        write(io,5001)' xmin   = c87+',xdel*(ixnum/2)+xsh(1)
        write(io,5001)' xmax   = c87+',xdel*(ixnum/2+1)+xsh(1)
       endif
      endif        
      write(io,5000)' y-type = 2'
      if(tag.eq.'xy'.or.tag.eq.'yz')then
       write(io,5002)' ny     = ',iynum
       if(iorg.eq.0)then
        write(io,5001)' ymin   = ',-0.5d0*ydist
        write(io,5001)' ymax   = ', 0.5d0*ydist
       else
        write(io,5001)' ymin   = c88+',0.5d0*(ydel*iynum-ydist)+xsh(2)
        write(io,5001)' ymax   = c88+',0.5d0*(ydel*iynum+ydist)+xsh(2)
       endif
      elseif(tag.eq.'xz')then
       write(io,5002)' ny     = ',1
       if(iorg.eq.0)then
        if(mod(ixnum,2).eq.1)then
         write(io,5001)' ymin   = ',-ydel/2.0d0
         write(io,5001)' ymax   = ', ydel/2.0d0
        else
         write(io,5001)' ymin   = ',0.0d0
         write(io,5001)' ymax   = ',ydel
        endif
       else
        write(io,5001)' ymin   = c88+',ydel*(iynum/2)+xsh(2)
        write(io,5001)' ymax   = c88+',ydel*(iynum/2+1)+xsh(2)
       endif
      endif
      write(io,5000)' z-type = 2'
      if(tag.eq.'yz'.or.tag.eq.'xz')then
       write(io,5002)' nz     = ',iznum
       if(iorg.eq.0)then
        write(io,5001)' zmin   = ',-0.5d0*zdist
        write(io,5001)' zmax   = ', 0.5d0*zdist
       else
        write(io,5001)' zmin   = c89+',0.5d0*(zdel*iznum-zdist)+xsh(3)
        write(io,5001)' zmax   = c89+',0.5d0*(zdel*iznum+zdist)+xsh(3)
       endif
      elseif(tag.eq.'xy')then
       write(io,5002)' nz     = ',1
       if(iorg.eq.0)then
        if(mod(iznum,2).eq.1)then
         write(io,5001)' zmin   = ',-zdel/2.0d0
         write(io,5001)' zmax   = ', zdel/2.0d0
        else
         write(io,5001)' zmin   = ',0.0d0
         write(io,5001)' zmax   = ',zdel
        endif
       else
        write(io,5001)' zmin   = c89+',zdel*(iznum/2)+xsh(3)
        write(io,5001)' zmax   = c89+',zdel*(iznum/2+1)+xsh(3)
       endif          
      endif        
      write(io,5000)' e-type = 1'
      write(io,5000)' ne     = 1'
      write(io,5000)'          0.0 2000.0'
      write(io,5000)' unit   = 1'
      write(io,5003)' axis   = ',tag
      write(io,5000)' gshow  = 1'
      write(io,5000)' gslat  = 0'
      write(io,5000)'$ resol  = 2'
      write(io,5000)' epsout = 1'
 5000 format(a)
 5001 format(a,'(',f12.5,')')
 5002 format(a,i4)
 5003 format(3a)
      return
      end subroutine CREATEttrack
!----------------------------------------------------------------------
      subroutine CREATEtheat(io,iorg,
     &     ixnum,iynum,iznum,xdel,ydel,zdel,xsh,tag)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io,iorg
      integer,intent(in) :: ixnum,iynum,iznum
      real(8),intent(in) :: xdel,ydel,zdel
      real(8),intent(in) :: xsh(3)
      character(2),intent(in) :: tag
      real(8) :: xdist,ydist,zdist

      xdist=xdel*ixnum
      ydist=ydel*iynum
      zdist=zdel*iznum
      if(tag.eq.'xy')then
        xdist=max(xdist,0.5d0*ydist)
        ydist=max(ydist,0.5d0*xdist)
      elseif(tag.eq.'yz')then
        zdist=max(zdist,0.5d0*ydist)
        ydist=max(ydist,0.5d0*zdist)
      elseif(tag.eq.'xz')then
        zdist=max(zdist,0.5d0*xdist)
        xdist=max(xdist,0.5d0*zdist)
      else
        write(*,*)'ERROR: tag should be xy or yz or xz'
      endif

      write(io,5000)' title  = [t-heat: icntl=0]'
      write(io,5003)' file   = heat-',tag,'.out'
      write(io,5000)' mesh   = xyz'
      write(io,5000)' x-type = 2'
      if(tag.eq.'xy'.or.tag.eq.'xz')then
       write(io,5002)' nx     = ',ixnum
       if(iorg.eq.0)then
        write(io,5001)' xmin   = ',-0.5d0*xdist
        write(io,5001)' xmax   = ', 0.5d0*xdist
       else
        write(io,5001)' xmin   = c87+',0.5d0*(xdel*ixnum-xdist)+xsh(1)
        write(io,5001)' xmax   = c87+',0.5d0*(xdel*ixnum+xdist)+xsh(1)
       endif          
      elseif(tag.eq.'yz')then
       write(io,5002)' nx     = ',1
       if(iorg.eq.0)then
        if(mod(ixnum,2).eq.1)then
         write(io,5001)' xmin   = ',-xdel/2.0d0
         write(io,5001)' xmax   = ', xdel/2.0d0
        else
         write(io,5001)' xmin   = ',0.0d0
         write(io,5001)' xmax   = ',xdel
        endif
       else
        write(io,5001)' xmin   = c87+',xdel*(ixnum/2)+xsh(1)
        write(io,5001)' xmax   = c87+',xdel*(ixnum/2+1)+xsh(1)
       endif
      endif        
      write(io,5000)' y-type = 2'
      if(tag.eq.'xy'.or.tag.eq.'yz')then
       write(io,5002)' ny     = ',iynum
       if(iorg.eq.0)then
        write(io,5001)' ymin   = ',-0.5d0*ydist
        write(io,5001)' ymax   = ', 0.5d0*ydist
       else
        write(io,5001)' ymin   = c88+',0.5d0*(ydel*iynum-ydist)+xsh(2)
        write(io,5001)' ymax   = c88+',0.5d0*(ydel*iynum+ydist)+xsh(2)
       endif
      elseif(tag.eq.'xz')then
       write(io,5002)' ny     = ',1
       if(iorg.eq.0)then
        if(mod(ixnum,2).eq.1)then
         write(io,5001)' ymin   = ',-ydel/2.0d0
         write(io,5001)' ymax   = ', ydel/2.0d0
        else
         write(io,5001)' ymin   = ',0.0d0
         write(io,5001)' ymax   = ',ydel
        endif
       else
        write(io,5001)' ymin   = c88+',ydel*(iynum/2)+xsh(2)
        write(io,5001)' ymax   = c88+',ydel*(iynum/2+1)+xsh(2)
       endif
      endif
      write(io,5000)' z-type = 2'
      if(tag.eq.'yz'.or.tag.eq.'xz')then
       write(io,5002)' nz     = ',iznum
       if(iorg.eq.0)then
        write(io,5001)' zmin   = ',-0.5d0*zdist
        write(io,5001)' zmax   = ', 0.5d0*zdist
       else
        write(io,5001)' zmin   = c89+',0.5d0*(zdel*iznum-zdist)+xsh(3)
        write(io,5001)' zmax   = c89+',0.5d0*(zdel*iznum+zdist)+xsh(3)
       endif
      elseif(tag.eq.'xy')then
       write(io,5002)' nz     = ',1
       if(iorg.eq.0)then
        if(mod(iznum,2).eq.1)then
         write(io,5001)' zmin   = ',-zdel/2.0d0
         write(io,5001)' zmax   = ', zdel/2.0d0
        else
         write(io,5001)' zmin   = ',0.0d0
         write(io,5001)' zmax   = ',zdel
        endif
       else
        write(io,5001)' zmin   = c89+',zdel*(iznum/2)+xsh(3)
        write(io,5001)' zmax   = c89+',zdel*(iznum/2+1)+xsh(3)
       endif          
      endif        
      write(io,5000)' electron = 1'
      write(io,5000)' unit   = 2'
      write(io,5003)' axis   = ',tag
      write(io,5000)' gshow  = 1'
      write(io,5000)' gslat  = 0'
      write(io,5000)' output = heat'
      write(io,5000)' epsout = 1'
      write(io,5000)'$ resol  = 2'
 5000 format(a)
 5001 format(a,'(',f12.5,')')
 5002 format(a,i4)
 5003 format(3a)
      return
      end subroutine CREATEtheat
      
!----------------------------------------------------------------------
      subroutine CREATEtdeposit(io,iorg,
     &     ixnum,iynum,iznum,xdel,ydel,zdel,xsh,tag)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io,iorg
      integer,intent(in) :: ixnum,iynum,iznum
      real(8),intent(in) :: xdel,ydel,zdel
      real(8),intent(in) :: xsh(3)
      character(2),intent(in) :: tag
      real(8) :: xdist,ydist,zdist

      xdist=xdel*ixnum
      ydist=ydel*iynum
      zdist=zdel*iznum
      if(tag.eq.'xy')then
        xdist=max(xdist,0.5d0*ydist)
        ydist=max(ydist,0.5d0*xdist)
      elseif(tag.eq.'yz')then
        zdist=max(zdist,0.5d0*ydist)
        ydist=max(ydist,0.5d0*zdist)
      elseif(tag.eq.'xz')then
        zdist=max(zdist,0.5d0*xdist)
        xdist=max(xdist,0.5d0*zdist)
      else
        write(*,*)'ERROR: tag should be xy or yz or xz'
      endif

      write(io,5000)' title  = [t-deposit: icntl=0]'
      write(io,5003)' file   = deposit-',tag,'.out'
      write(io,5000)' mesh   = xyz'
      write(io,5000)' x-type = 2'
      if(tag.eq.'xy'.or.tag.eq.'xz')then
       write(io,5002)' nx     = ',ixnum
       if(iorg.eq.0)then
        write(io,5001)' xmin   = ',-0.5d0*xdist
        write(io,5001)' xmax   = ', 0.5d0*xdist
       else
        write(io,5001)' xmin   = c87+',0.5d0*(xdel*ixnum-xdist)+xsh(1)
        write(io,5001)' xmax   = c87+',0.5d0*(xdel*ixnum+xdist)+xsh(1)
       endif          
      elseif(tag.eq.'yz')then
       write(io,5002)' nx     = ',1
       if(iorg.eq.0)then
        if(mod(ixnum,2).eq.1)then
         write(io,5001)' xmin   = ',-xdel/2.0d0
         write(io,5001)' xmax   = ', xdel/2.0d0
        else
         write(io,5001)' xmin   = ',0.0d0
         write(io,5001)' xmax   = ',xdel
        endif
       else
        write(io,5001)' xmin   = c87+',xdel*(ixnum/2)+xsh(1)
        write(io,5001)' xmax   = c87+',xdel*(ixnum/2+1)+xsh(1)
       endif
      endif        
      write(io,5000)' y-type = 2'
      if(tag.eq.'xy'.or.tag.eq.'yz')then
       write(io,5002)' ny     = ',iynum
       if(iorg.eq.0)then
        write(io,5001)' ymin   = ',-0.5d0*ydist
        write(io,5001)' ymax   = ', 0.5d0*ydist
       else
        write(io,5001)' ymin   = c88+',0.5d0*(ydel*iynum-ydist)+xsh(2)
        write(io,5001)' ymax   = c88+',0.5d0*(ydel*iynum+ydist)+xsh(2)
       endif
      elseif(tag.eq.'xz')then
       write(io,5002)' ny     = ',1
       if(iorg.eq.0)then
        if(mod(ixnum,2).eq.1)then
         write(io,5001)' ymin   = ',-ydel/2.0d0
         write(io,5001)' ymax   = ', ydel/2.0d0
        else
         write(io,5001)' ymin   = ',0.0d0
         write(io,5001)' ymax   = ',ydel
        endif
       else
        write(io,5001)' ymin   = c88+',ydel*(iynum/2)+xsh(2)
        write(io,5001)' ymax   = c88+',ydel*(iynum/2+1)+xsh(2)
       endif
      endif
      write(io,5000)' z-type = 2'
      if(tag.eq.'yz'.or.tag.eq.'xz')then
       write(io,5002)' nz     = ',iznum
       if(iorg.eq.0)then
        write(io,5001)' zmin   = ',-0.5d0*zdist
        write(io,5001)' zmax   = ', 0.5d0*zdist
       else
        write(io,5001)' zmin   = c89+',0.5d0*(zdel*iznum-zdist)+xsh(3)
        write(io,5001)' zmax   = c89+',0.5d0*(zdel*iznum+zdist)+xsh(3)
       endif
      elseif(tag.eq.'xy')then
       write(io,5002)' nz     = ',1
       if(iorg.eq.0)then
        if(mod(iznum,2).eq.1)then
         write(io,5001)' zmin   = ',-zdel/2.0d0
         write(io,5001)' zmax   = ', zdel/2.0d0
        else
         write(io,5001)' zmin   = ',0.0d0
         write(io,5001)' zmax   = ',zdel
        endif
       else
        write(io,5001)' zmin   = c89+',zdel*(iznum/2)+xsh(3)
        write(io,5001)' zmax   = c89+',zdel*(iznum/2+1)+xsh(3)
       endif          
      endif        
      write(io,5000)' unit   = 1'
      write(io,5003)' axis   = ',tag
      write(io,5000)' gshow  = 1'
      write(io,5000)' gslat  = 0'
      write(io,5000)' output = dose'
      write(io,5000)' epsout = 1'
      write(io,5000)'$ resol  = 2'
 5000 format(a)
 5001 format(a,'(',f12.5,')')
 5002 format(a,i4)
 5003 format(3a)
      return
      end subroutine CREATEtdeposit
!----------------------------------------------------------------------
      subroutine CREATEt3Ddeposit(io,ixnum,iynum,iznum,
     &     xsh,xdel,ydel,zdel)
!----------------------------------------------------------------------
      implicit none
      integer,intent(in) :: io
      integer,intent(in) :: ixnum,iynum,iznum
      real(8),intent(in) :: xsh(3)
      real(8),intent(in) :: xdel,ydel,zdel
      real(8) :: xdist,ydist,zdist

      xdist=xdel*ixnum
      ydist=ydel*iynum
      zdist=zdel*iznum

      write(io,5000)' title  = [t-deposit: icntl=0]'
      write(io,5000)' file   = deposit-3D.out'
      write(io,5000)' mesh   = xyz'
      write(io,5000)' x-type = 2'
      write(io,5002)' nx     = ',ixnum
      write(io,5001)' xmin   = c87+',xsh(1)
      write(io,5001)' xmax   = c87+',xsh(1)+xdist
      write(io,5000)' y-type = 2'
      write(io,5002)' ny     = ',iynum
      write(io,5001)' ymin   = c88+',xsh(2)
      write(io,5001)' ymax   = c88+',xsh(2)+ydist
      write(io,5000)' z-type = 2'
      write(io,5002)' nz     = ',iznum
      write(io,5001)' zmin   = c89+',xsh(3)
      write(io,5001)' zmax   = c89+',xsh(3)+zdist
      write(io,5000)' unit   = 0'
      write(io,5000)' axis   = xy'
      write(io,5000)' gshow  = 0'
      write(io,5000)' gslat  = 0'
      write(io,5000)' output = dose'
      write(io,5000)' epsout = 0'
      write(io,5000)'$ resol  = 2'
 5000 format(a)
 5001 format(a,'(',f12.5,')')
 5002 format(a,i4)
      return
      end subroutine CREATEt3Ddeposit
!----------------------------------------------------------------------
      end module createfile
      
