#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <time.h>
#include <ctype.h>
#include "dicomlib.h"
#include "dicomdict.h"
#define BS_BYTE1(x) (  x        & 0xFF )
#define BS_BYTE2(x) ( (x >>  8) & 0xFF )
#define BS_BYTE3(x) ( (x >> 16) & 0xFF )
#define BS_BYTE4(x) ( (x >> 24) & 0xFF )
#define BS_INT16(x) ( (unsigned short)(BS_BYTE1(x)<<8 | BS_BYTE2(x)) )
#define BS_INT32(x) ( BS_BYTE1(x)<<24 | BS_BYTE2(x)<<16 | BS_BYTE3(x)<<8 | BS_BYTE4(x) )
/********** Module variables ***********************************************/
extern int ifendian,imendian,imatch;
extern char Fout[1024];
#define Nloop 2000
#define NTDICOM 43
int itagjump[NTDICOM]={0};
struct TARGETTAG ttag[NTDICOM] = {
  {0,  0x0008,0x0012,"CH0","Instance Creation Date"},
  {1,  0x0008,0x0013,"CH0","Instance Creation Time"},
  {2,  0x0008,0x0020,"CH0","Study Date"},
  {3,  0x0008,0x0023,"CH0","Content Date"},
  {4,  0x0008,0x0030,"CH0","Study Time"},
  {5,  0x0008,0x0033,"CH0","Content Time"},
  {6,  0x0008,0x0060,"CH0","Modality"},
  {7,  0x0008,0x0070,"CH0","Manufacturer"},
  {8,  0x0008,0x0080,"CH0","Institution Name"},
  {9,  0x0008,0x1010,"CH0","Station Name"},
  {10, 0x0008,0x1040,"CH0","Institutional Department Name"},
  {11, 0x0008,0x1090,"CH0","Manufacturer Model Name"},
  {12, 0x0010,0x0010,"CH0","Patient Name"},
  {13, 0x0010,0x0020,"CH0","Patient ID"},
  {14, 0x0010,0x0030,"CH0","Patient Birth Date"},
  {15, 0x0010,0x0040,"CH0","Patient Sex"},
  {16, 0x0018,0x0050,"DS1","Slice Thickness"},
  {17, 0x0018,0x0088,"DS1","Spacing Between Slices"},
  {18, 0x0018,0x1000,"CH0","Device Serial Number"},
  {19, 0x0018,0x1020,"CH0","Software Versions"},
  {20, 0x0020,0x0010,"CH0","Study ID"},
  {21, 0x0020,0x0011,"CH0","Series Number"},
  {22, 0x0020,0x0013,"CH0","Instace Number"},
  {23, 0x0020,0x0032,"DS3","Image Position Patient"},
  {24, 0x0020,0x0037,"DS6","Image Orientation Patient"},
  {25, 0x0020,0x0052,"CH0","Frame Of Reference UID"},
  {26, 0x0020,0x1040,"CH0","Position Reference Indicator"},
  {27, 0x0020,0x1041,"DS1","Slice Location"},
  {28, 0x0028,0x0008,"IS1","Number of Frames"},
  {29, 0x0028,0x0009,"CH0","Frame Increment Pointer"},
  {30, 0x0028,0x0010,"US1","Rows"},
  {31, 0x0028,0x0011,"US1","Columns"},
  {32, 0x0028,0x0030,"DS2","Pixel Spacing"},
  {33, 0x0028,0x0100,"US1","Bits Allocated"},
  {34, 0x0028,0x0101,"US1","Bits Stored"},
  {35, 0x0028,0x0102,"US1","High Bit"},
  {36, 0x0028,0x1052,"DS1","Rescale Intercept"},
  {37, 0x0028,0x1053,"DS1","Rescale Slope"},
  {38, 0x3004,0x0004,"CH0","Dose Type"},
  {39, 0x3004,0x0008,"DS1","Normalization Point"},
  {40, 0x3004,0x000C,"DS0","Grid Frame Offset Vector"},
  {41, 0x3004,0x000E,"DS1","Dose Grid Scaling"},
  {42, 0x7FE0,0x0010,"CH0","Pixel Data"}
};
char csdate[256],ccdate[256],cstime[256],cctime[256];
char cinst[256],cpname[256],cpid[256],cpbirth[256],cpsex[256];
char cstid[256],csnum[256],cframeid[256],cposi[256];
#define max_cb 1024
char cbuff[max_cb];
char cfname[max_cb];

/********** Prototype decllaration *****************************************/
int check_dicom(FILE *);
int check_modality(FILE *,char *);
int find_tag(unsigned short,unsigned short,char *,char *);
int get_buff(FILE *,unsigned int,char *);
int get_bytes(FILE *,char *,unsigned int *,int *,unsigned char *,unsigned char *);
int get_cshort(FILE *,struct TARGETTAG *,char *);
int get_dicomdata(FILE *,int,int,float *);
int get_dicomheader(FILE *,struct TARGETTAG *,unsigned int *,char *);
void get_error(struct TARGETTAG *);
int get_tag(FILE *,unsigned short *,unsigned short *);
void get_warn(struct TARGETTAG *);
int get_DS(FILE *,struct TARGETTAG *,double *);
int get_DS2(FILE *,struct TARGETTAG *,double *,double *);
int get_DS3(FILE *,struct TARGETTAG *,double *);
int get_DS6(FILE *,struct TARGETTAG *,double *,double *);
int get_DSseq(FILE *,struct TARGETTAG *,unsigned int *,char *);
int get_IS(FILE *,struct TARGETTAG *,int *);
int get_US(FILE *,struct TARGETTAG *,int *);
int overwrite_dicomheader(FILE *,struct TARGETTAG *,unsigned int,char *);
int overwrite_cshort(FILE *,struct TARGETTAG *,char *);
int overwrite_DS(FILE *,struct TARGETTAG *,double);
int overwrite_DS2(FILE *,struct TARGETTAG *,double,double);
int overwrite_DS3(FILE *,struct TARGETTAG *,double,double,double);
int overwrite_DSseq(FILE *,struct TARGETTAG *,int,double);
int overwrite_IS(FILE *,struct TARGETTAG *,int);
int overwrite_US(FILE *,struct TARGETTAG *,int);
void print_dicomheader(FILE *,unsigned short,unsigned short,
		       char *,char *,char *,unsigned int);
int readwrite_buff(FILE *,FILE *,unsigned int);
int readwrite_dicom(FILE *,FILE *);
void set_bytes(unsigned int,int,unsigned char *,unsigned char *);
void switchdtag_endian(void);
void switchttag_endian(void);
int write_buff(FILE *,unsigned int,char *);
int write_bytes(FILE *,int,unsigned char *,unsigned char *);
int write_tag(FILE *,unsigned short,unsigned short);

/********** Module functions ********************************************/
int open_file(FILE **fp,char *fname,char *mode)
{
  memset(cfname,0,max_cb);
  strcpy(cfname,fname);
  *fp = fopen(fname,mode);
  if(*fp == NULL) {
    printf(" ERROR:: Openning file: %s\n",fname);
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int close_file(FILE *fp)
{
  int ierr;
  ierr = fclose(fp);
  if(ierr == EOF) {
    printf("ERROR:: Closing output file\n");
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int copy_binary(FILE *fp1,FILE *fp2)
{
  int max_num=1000000;
  unsigned char buff[max_num];
  int size;
  size=max_num;
  while(size==max_num){
    size=(int)fread(buff,sizeof(unsigned char),max_num,fp1);
    if(fwrite(buff,sizeof(unsigned char),size,fp2)!=size)return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int check_file(FILE *fp,char *cin)
{
  int ierr;
  if(eval_ifendian(fp)!=0)return(-1);
  ierr=check_modality(fp,cin);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int check_modality(FILE *fp,char *cin)
{
  char cmod[256];
  int len;
  if(get_cshort(fp,&ttag[6],cmod)==0){ // Modality
    len=strlen(cmod);
    if(strncmp(cin,cmod,len)!=0){
      printf(" ERROR:: File Modality dose not match\n");
      printf(" expected = %s\n",cin);
      printf(" found    = %s\n",cmod);
      return(-1);
    }      
  }else{
    printf(" ERROR:: Modality tag could not be obtained\n");
    return(-1);
  }
  rewind(fp);
  return(0);
}
/*-------------------------------------------------------------------------*/
void switchttag_endian()
{
  int i;
  for(i=0;i<NTDICOM;i++){
    ttag[i].group=BS_INT16(ttag[i].group);
    ttag[i].element=BS_INT16(ttag[i].element);
  }
  return;
}
/*-------------------------------------------------------------------------*/
void switchdtag_endian()
{
  int i;
  for(i=0;i<NDICOM;i++){
    dtag[i].group=BS_INT16(dtag[i].group);
    dtag[i].element=BS_INT16(dtag[i].element);
  }
  return;
}
/*-------------------------------------------------------------------------*/
int readwrite_dicomheader(FILE *fp0,FILE *fp)
{
  unsigned short group,element;
  char vr[3],name[128];
  unsigned char sbuff1[4],sbuff2[4];
  unsigned int nbytes;
  int i,iflag;
  if(check_dicom(fp0)!=0){
    printf(" ERROR:: File is not DICOM format\n");
    exit(-1);
  }
  for(i=0;i<Nloop;i++){
    if(get_tag(fp0,&group,&element)!=0)break;
    if(find_tag(group,element,vr,name)!=0){
      strcpy(vr,"UN");
      strcpy(name,"Unknown");
    }
    if(get_bytes(fp0,vr,&nbytes,&iflag,sbuff1,sbuff2)!=0)return(-1);
    if(get_buff(fp0,nbytes,cbuff)!=0){
      printf(" ERROR:: Reading DICOM header\n");
      return(-1);
    }
    print_dicomheader(fp,group,element,vr,name,cbuff,nbytes);
  }
  if(i>999){
    printf(" ERROR:: More than Nloop headers\n");
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
void print_dicomheader(FILE *fp,unsigned short group,unsigned short element,
		      char *vr,char *name,char *buff,unsigned int nbytes)
{
  int iflag=0;
  unsigned short usdata;
  unsigned long uldata;
  short ssdata;
  long sldata;
  printf("-------------------------\n");
  printf("Group=%04x Element=%04x\n",group,element);
  printf("VR=%s Nbytes=%d\n",vr,nbytes);
  printf("   %s\n",name);
  fprintf(fp,"-------------------------\n");
  fprintf(fp,"Group=%04x Element=%04x\n",group,element);
  fprintf(fp,"VR=%s Nbytes=%d\n",vr,nbytes);
  fprintf(fp,"   %s\n",name);
  switch(vr[0]){
  case 'A':
    switch(vr[1]){
    case 'T':
      iflag=1;
      break;
    }
    break;
  case 'F':
    switch(vr[1]){
    case 'L':
      iflag=1;
      break;
    case 'D':
      iflag=1;
      break;
    }
    break;
  case 'O':
    switch(vr[1]){
    case 'B':
      iflag=1;
      break;
    case 'F':
      iflag=1;
      break;
    case 'X':
      iflag=1;
      break;
    case 'W':
      iflag=1;
      break;
    }
    break;
  case 'S':
    switch(vr[1]){
    case 'L':
      iflag=1;
      if(ifendian==1){
	sldata=(long)((buff[0]&0xff)|
		      ((buff[1]<<8)&0xff00)|
		      ((buff[2]<<16)&0xff0000)|
		      ((buff[3]<<24)&0xff000000));
      }else{
	sldata=(long)((buff[3]&0xff)|
		      ((buff[2]<<8)&0xff00)|
		      ((buff[1]<<16)&0xff0000)|
		      ((buff[0]<<24)&0xff000000));
      }
      printf("Value=%ld/n",sldata);
      fprintf(fp,"Value=%ld/n",sldata);
      break;
    case 'Q':
      iflag=1;
      break;
    case 'S':
      iflag=1;
      if(ifendian==1){
	ssdata=(short)((buff[0]&0xff)|((buff[1]<<8)&0xff00));
      }else{
	ssdata=(short)((buff[1]&0xff)|((buff[0]<<8)&0xff00));
      }
      printf("Value=%d\n",ssdata);
      fprintf(fp,"Value=%d\n",ssdata);
      break;
    }
    break;
  case 'U':
    switch(vr[1]){
    case 'L':
      iflag=1;
      if(ifendian==1){
	uldata=(unsigned long)((buff[0]&0xff)|
			       ((buff[1]<<8)&0xff00)|
			       ((buff[2]<<16)&0xff0000)|
			       ((buff[3]<<24)&0xff000000));
      }else{
	uldata=(unsigned long)((buff[3]&0xff)|
			       ((buff[2]<<8)&0xff00)|
			       ((buff[1]<<16)&0xff0000)|
			       ((buff[0]<<24)&0xff000000));
      }
      printf("Value=%lu\n",uldata);
      fprintf(fp,"Value=%lu\n",uldata);
      break;
    case 'S':
      iflag=1;
      if(ifendian==1){
	usdata=(unsigned short)((buff[0]&0xff)|((buff[1]<<8)&0xff00));
      }else{
	usdata=(unsigned short)((buff[1]&0xff)|((buff[0]<<8)&0xff00));
      }
      printf("Value=%u\n",usdata);
      fprintf(fp,"Value=%u\n",usdata);
      break;
    }
    break;
  }
  if(iflag==0){
    printf("Value=%s\n",buff);
    fprintf(fp,"Value=%s\n",buff);
  }    
}
/*-------------------------------------------------------------------------*/
int get_buff(FILE *fp,unsigned int nbytes0,char *buff)
{
  unsigned int nbytes,nrest;
  char buff2[max_cb];
  memset(buff,0,max_cb);
  nbytes=nbytes0;
  if(nbytes0>max_cb)nbytes=max_cb;
  if(fread(buff,sizeof(char),nbytes,fp)!=nbytes)return(-1);
  nrest=nbytes0-nbytes;
  while(nrest>0){
    nbytes=nrest;
    if(nrest>max_cb)nbytes=max_cb;
    if(fread(buff2,sizeof(char),nbytes,fp)!=nbytes)return(-1);
    nrest=nrest-nbytes;
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int get_bytes(FILE *fp,char *vr,unsigned int *nbytes,int *iflag,
	      unsigned char *sbuff1,unsigned char *sbuff2)
{
  *iflag=0;
  memset(sbuff1,0,4);
  memset(sbuff2,0,4);
  if(fread(sbuff1,sizeof(char),4,fp)!=4)return(-1);
  switch(sbuff1[0]){
  case 'O':
    switch(sbuff1[1]){
    case 'B':
    case 'W':
    case 'F':
      *iflag=1;
      break;
    }
    break;
  case 'U':
    switch(sbuff1[1]){
    case 'T':
    case 'N':
      *iflag=1;
      break;
    }
    break;
  case 'S':
    switch(sbuff1[1]){
    case 'Q':
      *iflag=1;
      break;
    }
    break;
  }
  if(*iflag==0){
    if(isupper(sbuff1[0]) && isupper(sbuff1[1])){
      if(ifendian==1){ // File is written in Little Endian
	*nbytes=sbuff1[2]+sbuff1[3]*256;
      }else{ // File is written in Big Endian
	*nbytes=sbuff1[2]*256+sbuff1[3];
      }
    }else{
      if(ifendian==1){ // File is written in Little Endian
	*nbytes=sbuff1[0]+sbuff1[1]*256+sbuff1[2]*256*256+sbuff1[3]*256*256*256;
      }else{ // File is written in Big Endian
	*nbytes=sbuff1[0]*256*256*256+sbuff1[1]*256*256+sbuff1[2]*256+sbuff1[3];
      }
    }
  }else{
    if(fread(sbuff2,sizeof(char),4,fp)!=4)return(-1);
    if(ifendian==1){ // File is written in Little Endian
      *nbytes=sbuff2[0]+sbuff2[1]*256+sbuff2[2]*256*256+sbuff2[3]*256*256*256;
    }else{ // File is written in Big Endian
      *nbytes=sbuff2[0]*256*256*256+sbuff2[1]*256*256+sbuff2[2]*256+sbuff2[3];
    }
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int eval_ifendian(FILE *fp)
{
  unsigned short group,element;
  unsigned short groupB,groupL,elementB,elementL;
  char vr[3],name[128];
  unsigned char sbuff[2];
  if(check_dicom(fp)!=0)return(-1);
  if(get_tag(fp,&group,&element)!=0)return(-1);
  if(imendian==1){
    groupL=group;
    elementL=element;
    groupB=BS_INT16(group);
    elementB=BS_INT16(element);
  }else{
    groupB=group;
    elementB=element;
    groupL=BS_INT16(group);
    elementL=BS_INT16(element);
  }
  if(find_tag(groupB,elementB,vr,name)!=0)ifendian=1;
  fread(sbuff,sizeof(char),2,fp);
  if(ifendian==0){
    if(vr[0]==sbuff[0] && vr[1]==sbuff[1]){
      ifendian=-1;
    }else{
      ifendian=1;
    }
  }
  if(ifendian==1){
    if(find_tag(groupL,elementL,vr,name)!=0){
      printf(" ERROR:: File endian could not be identified\n");
      return(-1);
    }
  }
  if(ifendian==imendian){
    imatch=0;
  }else{
    imatch=1;
  }
  if(imatch==1){
    switchdtag_endian();
    switchttag_endian();
  }
  rewind(fp);
  return(0);
}
/*-------------------------------------------------------------------------*/
int get_tag(FILE *fp,unsigned short *group,unsigned short *element)
{
  if(fread(group,sizeof(short),1,fp)<1)return(-1);
  if(fread(element,sizeof(short),1,fp)<1)return(-1);
  return(0);
}
/*-------------------------------------------------------------------------*/
int find_tag(unsigned short group,unsigned short element,char *vr0,char *name0)
{
  int i;
  for(i=0;i<NDICOM;i++){
    if(dtag[i].group==group && dtag[i].element==element){
      memset(vr0,0,3);
      memset(name0,0,128);
      strncpy(vr0,dtag[i].vr,3);
      strncpy(name0,dtag[i].name,128);
      return(0);
    }
  }
  return(-1);
}
/*-------------------------------------------------------------------------*/
int check_dicom(FILE *fp)
{
  char dicmt[5]="DICM",buff[128];
  int ierr;
  ierr=0;
  if((fread(buff,sizeof(char),128,fp))<128)ierr=1;
  if(ierr==0 && (fread(buff,sizeof(char),4,fp))<4)ierr=1;
  buff[4]='\0';
  if(ierr==0 && (strcmp(buff,dicmt))!=0)ierr=1;
  if(ierr!=0)return(-1);
  return(0);
}
/*-------------------------------------------------------------------------*/
int readwrite_dicom(FILE *fp0,FILE *fp)
{
  char buff[132];
  int ierr;
  ierr=0;
  if((fread(buff,sizeof(char),132,fp0))<132)ierr=1;
  if((fwrite(buff,sizeof(char),132,fp))<132)ierr=1;
  if(ierr!=0){
    printf(" ERROR:: Format file is not DICOM\n");
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
void switch_endian()
{
  int i;
  for(i=0;i<NDICOM;i++){
    dtag[i].group=BS_INT16(dtag[i].group);
    dtag[i].element=BS_INT16(dtag[i].element);
  }
  return;
}
/*-------------------------------------------------------------------------*/
void get_RTdoseheader(FILE *fp)
{
  int nx=-9999,ny=-9999,nz=-9999;
  //  int nalloc,nstore,nhigh;
  double xdel,ydel;
  double xsh[3],xvec[3],yvec[3],xnorm[3];
  double dgscale=-9999.0;
  char clong[max_cb];
  char cdate[256],ctime[256];
  unsigned int len;
  
  if(get_cshort(fp,&ttag[0],cdate)!=0)get_error(&ttag[0]); // Instance Creation Date
  rewind(fp);
  if(get_cshort(fp,&ttag[1],ctime)!=0)get_error(&ttag[1]); // Instance Creation Time
  rewind(fp);
  if(get_DS3(fp,&ttag[23],xsh)!=0)get_error(&ttag[23]); // Image Position Patient
  rewind(fp);
  if(get_DS6(fp,&ttag[24],xvec,yvec)!=0)get_error(&ttag[24]); // Image Orientation Patient
  rewind(fp);
  if(get_IS(fp,&ttag[28],&nz)!=0)get_error(&ttag[28]); // Number of Frames
  rewind(fp);
  if(get_US(fp,&ttag[30],&ny)!=0)get_error(&ttag[30]); // Rows
  rewind(fp);
  if(get_US(fp,&ttag[31],&nx)!=0)get_error(&ttag[31]); // Columns
  rewind(fp);
  if(get_DS2(fp,&ttag[32],&xdel,&ydel)!=0)get_error(&ttag[32]); // Pixel Spacing
  rewind(fp);
  /* nalloc=get_US(fp,&ttag[33]); */
  /* rewind(fp); */
  /* nstore=get_US(fp,&ttag[34]); */
  /* rewind(fp); */
  /* nhigh=get_US(fp,&ttag[35]); */
  /* rewind(fp); */
  if(get_DS3(fp,&ttag[39],xnorm)!=0)get_error(&ttag[39]); // Normalization Point
  rewind(fp);
  if(get_DSseq(fp,&ttag[40],&len,clong)!=0)get_error(&ttag[40]); // Grid Frame Offset Vector
  rewind(fp);
  if(get_DS(fp,&ttag[41],&dgscale)!=0)get_error(&ttag[41]); // Dose Grid Scaling
  rewind(fp);

  printf("Date=%8.8s\n",cdate);
  printf("Time=%6.6s\n",ctime);
  printf("offset position=%lf %lf %lf\n",xsh[0],xsh[1],xsh[2]);
  printf("nx=%d ny=%d nz=%d\n",nx,ny,nz);
  printf("xdel=%lf ydel=%lf\n",xdel,ydel);
  printf("normalization at position=%lf %lf %lf\n",xnorm[0],xnorm[1],xnorm[2]);
  printf("dgscale=%G\n",dgscale);
  printf("Grid Frame Offset Vector= %d bytes\n",len);

}
/*-------------------------------------------------------------------------*/
void get_RTimageheader0(FILE *fp,int *nx,int *ny,int *nalloc,
			double *xdel,double *ydel,double *zdel,
			double *hu0,double *slope,
			double *xsh,double *xvec,double *yvec)
{
  if(get_DS(fp,&ttag[17],zdel)!=0){ // Spacing Between Slices
    rewind(fp);
    if(get_DS(fp,&ttag[16],zdel)!=0)get_error(&ttag[16]); // Slice Thickness
  }
  rewind(fp);
  if(get_DS3(fp,&ttag[23],xsh)!=0)get_error(&ttag[23]); // Image Position Patient
  rewind(fp);
  if(get_DS6(fp,&ttag[24],xvec,yvec)!=0)get_error(&ttag[24]); // Image Orientation Patient
  rewind(fp);
  if(get_US(fp,&ttag[30],ny)!=0)get_error(&ttag[30]); // Rows
  rewind(fp);
  if(get_US(fp,&ttag[31],nx)!=0)get_error(&ttag[31]); // Columns
  rewind(fp);
  if(get_DS2(fp,&ttag[32],xdel,ydel)!=0)get_error(&ttag[32]); // Pixel Spacing
  rewind(fp);
  if(get_US(fp,&ttag[33],nalloc)!=0)get_error(&ttag[33]); // Columns
  rewind(fp);
  if(get_DS(fp,&ttag[36],hu0)!=0)get_error(&ttag[36]); // Rescale Intercept
  rewind(fp);
  if(get_DS(fp,&ttag[37],slope)!=0)get_error(&ttag[37]); // Rescale Slope
  rewind(fp);

  /* printf("nx=%d ny=%d\n",*nx,*ny); */
  /* printf("xdel=%lf ydel=%lf\n",*xdel,*ydel); */


}
/*-------------------------------------------------------------------------*/
void get_RTimageheader(FILE *fp)
{
  if(get_cshort(fp,&ttag[2],csdate)!=0)get_warn(&ttag[2]); // Study Date
  rewind(fp);
  if(get_cshort(fp,&ttag[3],ccdate)!=0)get_warn(&ttag[3]); // Content Date
  rewind(fp);
  if(get_cshort(fp,&ttag[4],cstime)!=0)get_warn(&ttag[4]); // Study Time
  rewind(fp);
  if(get_cshort(fp,&ttag[5],cctime)!=0)get_warn(&ttag[5]); // Content Time
  rewind(fp);
  if(get_cshort(fp,&ttag[8],cinst)!=0)get_warn(&ttag[8]); // Institution Name
  rewind(fp);
  if(get_cshort(fp,&ttag[12],cpname)!=0)get_warn(&ttag[12]); // Patient Name
  rewind(fp);
  if(get_cshort(fp,&ttag[13],cpid)!=0)get_warn(&ttag[13]); // Patient ID
  rewind(fp);
  if(get_cshort(fp,&ttag[14],cpbirth)!=0)get_warn(&ttag[14]); // Patient Birth Date
  rewind(fp);
  if(get_cshort(fp,&ttag[15],cpsex)!=0)get_warn(&ttag[15]); // Patient Sex
  rewind(fp);
  if(get_cshort(fp,&ttag[20],cstid)!=0)get_warn(&ttag[20]); // Study ID
  rewind(fp);
  if(get_cshort(fp,&ttag[21],csnum)!=0)get_warn(&ttag[21]); // Series Number
  rewind(fp);
  if(get_cshort(fp,&ttag[25],cframeid)!=0)get_warn(&ttag[25]); // Frame Of Reference UID
  rewind(fp);
  if(get_cshort(fp,&ttag[26],cposi)!=0)get_warn(&ttag[26]); // Position Reference Indicator
  rewind(fp);

  /* printf("Study Time =%10.10s\n",cstime); */
  /* printf("Content Time =%10.10s\n",cctime); */
  /* printf("Institution Name =%10.10s\n",cinst); */
  /* printf("Patient Name =%10.10s\n",cpname); */
  /* printf("Patient ID =%10.10s\n",cpid); */
  /* printf("Patient Birth Date =%10.10s\n",cpbirth); */
  /* printf("Patient Sex =%10.10s\n",cpsex); */
  /* printf("Study ID =%10.10s\n",cstid); */
  /* printf("Series Number =%10.10s\n",csnum); */
  /* printf("Frame Of Reference UID =%10.10s\n",cframeid); */
  /* printf("Position Reference Indicator =%10.10s\n",cposi); */
}
/*-------------------------------------------------------------------------*/
int get_RTimagedata(FILE *fp, int ndata, int nalloc,
		    double hu0, double slope, float *data)
{
  int i,ierr;
  ierr=get_dicomdata(fp,ndata,nalloc,data);
  if(ierr<0)return(-1);
  if(ierr>0){
    printf(" ERROR:: Reading RT image data %d-th\n",ierr);
    exit(-1);
  }
  rewind(fp);
  for(i=0;i<ndata;i++){
    data[i]=data[i]*slope+hu0;
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int overwrite_RTdoseheader(FILE *fp, double *xval, int *ngrid,
			   float dmax, int *ipmax, double *fac, 
			   int ifnorm, float *data, double *xn, double vnorm, 
			   char *cver, char *cdate, char *ctime)
{
  double xdel,ydel,zdel;
  double xsh[3];
  double xnorm;
  int ip[3],i0;
  int ierr;
  *fac=(double) dmax/(256*256-1);
  xdel=(xval[1]-xval[0])/ngrid[0];
  ydel=(xval[3]-xval[2])/ngrid[1];
  zdel=(xval[5]-xval[4])/ngrid[2];
  xsh[0]=xval[0]+0.5*xdel;
  xsh[1]=xval[2]+0.5*ydel;
  xsh[2]=xval[4]+0.5*zdel;
  if(ifnorm==0){
    xn[0]=xsh[0]+(*ipmax)*xdel;
    xn[1]=xsh[1]+(*(ipmax+1))*ydel;
    xn[2]=xsh[2]+(*(ipmax+2))*zdel;
    xnorm=(double)1.0/(256*256-1); // normalized the Max dose to 1
  }else{
    if(xn[0]<xval[0] || xn[0]>=xval[1]){
      printf(" ERROR:: Normalization point is outside of data range\n");
      printf("  Data range [mm]: x=%lf : %lf\n",xval[0],xval[1]);
      printf("  Specified [mm] : x=%lf\n",xn[0]);
      return(-1);
    }else if(xn[1]<xval[2] || xn[1]>=xval[3]){
      printf(" ERROR:: Normalization point is outside of data range\n");
      printf("  Data range [mm]: y=%lf : %lf\n",xval[2],xval[3]);
      printf("  Specified [mm] : y=%lf\n",xn[1]);
      return(-1);
    }else if(xn[2]<xval[4] || xn[2]>=xval[5]){
      printf(" ERROR:: Normalization point is outside of data range\n");
      printf("  Data range [mm]: z=%lf : %lf\n",xval[4],xval[5]);
      printf("  Specified [mm] : z=%lf\n",xn[2]);
      return(-1);
    }
    ip[0]=(xn[0]-xval[0])/xdel;
    ip[1]=(xn[1]-xval[2])/ydel;
    ip[2]=(xn[2]-xval[4])/zdel;
    i0=ip[0]+ip[1]*ngrid[0]+ip[2]*ngrid[0]*ngrid[1];
    if(data[i0]>0.0){
      xnorm=vnorm*(*fac)/data[i0];
    }else{
      printf("***********************************************************\n");
      printf(" WARNING:: Value at specified normalization point is zero\n");
      printf("           Normalization is changed to one for max dose\n");
      printf("***********************************************************\n");
      xn[0]=xsh[0]+(*ipmax)*xdel;
      xn[1]=xsh[1]+(*(ipmax+1))*ydel;
      xn[2]=xsh[2]+(*(ipmax+2))*zdel;
      xnorm=(double)1.0/(256*256-1); // normalized the Max dose to 1
    }
  }

  ierr=0;
  if(itagjump[0]==0){
    ierr+=overwrite_cshort(fp,&ttag[0],cdate); // Instance Creation Date
    rewind(fp);
  }
  if(itagjump[1]==0){
    ierr+=overwrite_cshort(fp,&ttag[1],ctime); // Instance Creation Time
    rewind(fp);
  }
  if(itagjump[2]==0){
    ierr+=overwrite_cshort(fp,&ttag[2],csdate); // Study Date
    rewind(fp);
  }
  if(itagjump[3]==0){
    ierr+=overwrite_cshort(fp,&ttag[3],ccdate); // Content Date
    rewind(fp);
  }
  if(itagjump[4]==0){
    ierr+=overwrite_cshort(fp,&ttag[4],cstime); // Study Time
    rewind(fp);
  }
  if(itagjump[5]==0){
    ierr+=overwrite_cshort(fp,&ttag[5],cctime); // Content Time
    rewind(fp);
  }
  /* ierr+=overwrite_cshort(fp,&ttag[7],"DICOM2PHITS"); // Manufacturer */
  /* rewind(fp); */
  if(itagjump[8]){
    ierr+=overwrite_cshort(fp,&ttag[8],cinst); // Institution Name
    rewind(fp);
  }
  /* ierr+=overwrite_cshort(fp,&ttag[9],"DICOM2PHITS"); // Station Name */
  /* rewind(fp); */
  /* ierr+=overwrite_cshort(fp,&ttag[10],"department none"); // Institutional Department Name */
  /* rewind(fp); */
  /* ierr+=overwrite_cshort(fp,&ttag[11],"PHITS"); // Manufacturer Model Name */
  /* rewind(fp); */
  if(itagjump[12]==0){
    ierr+=overwrite_cshort(fp,&ttag[12],cpname); // Patient Name
    rewind(fp);
  }
  if(itagjump[13]==0){
    ierr+=overwrite_cshort(fp,&ttag[13],cpid); // Patient ID
    rewind(fp);
  }
  if(itagjump[14]==0){
    ierr+=overwrite_cshort(fp,&ttag[14],cpbirth); // Patient Birth Date
    rewind(fp);
  }
  if(itagjump[15]==0){
    ierr+=overwrite_cshort(fp,&ttag[15],cpsex); // Patient Sex
    rewind(fp);
  }
  /* ierr+=overwrite_cshort(fp,&ttag[18],"PHITS"); // Device Serial Number */
  /* rewind(fp); */
  ierr+=overwrite_cshort(fp,&ttag[19],cver); // Software Versions
  rewind(fp);
  if(itagjump[20]==0){
    ierr+=overwrite_cshort(fp,&ttag[20],cstid); // Study ID
    rewind(fp);
  }
  if(itagjump[21]==0){
    ierr+=overwrite_cshort(fp,&ttag[21],csnum); // Series Number
    rewind(fp);
  }
  if(itagjump[23]==0){
    ierr+=overwrite_DS3(fp,&ttag[23],xsh[0],xsh[1],xsh[2]); // Image Position Patient
    rewind(fp);
  }
  if(itagjump[25]==0){
    ierr+=overwrite_cshort(fp,&ttag[25],cframeid); // Frame Of Reference UID
    rewind(fp);
  }
  if(itagjump[26]==0){
    ierr+=overwrite_cshort(fp,&ttag[26],cposi); // Position Reference Indicator
    rewind(fp);
  }
  ierr+=overwrite_IS(fp,&ttag[28],ngrid[2]); // Number of Frames
  rewind(fp);
  ierr+=overwrite_US(fp,&ttag[30],ngrid[1]); // Rows
  rewind(fp);
  ierr+=overwrite_US(fp,&ttag[31],ngrid[0]); // Columns
  rewind(fp);
  ierr+=overwrite_DS2(fp,&ttag[32],xdel,ydel); // Pixel Spacing
  rewind(fp);
  /* ierr+=overwrite_cshort(fp,&ttag[38],"PHYSICAL"); // Dose Type */
  /* rewind(fp); */
  ierr+=overwrite_DS3(fp,&ttag[39],xn[0],xn[1],xn[2]); // Normalization Point
  rewind(fp);
  ierr+=overwrite_DSseq(fp,&ttag[40],ngrid[2],zdel); // Grid Frame Offset Vector
  rewind(fp);
  ierr+=overwrite_DS(fp,&ttag[41],xnorm); // Dose Grid Scaling
  rewind(fp);

  if(ierr!=0){
    printf(" ERROR:: Overwritting DICOM header\n");
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int overwrite_RTdosedata(FILE *fp,double fac,int ngridtot,float *data)
{
  unsigned short group,element;
  char vr[3],name[128];
  unsigned char sbuff1[4],sbuff2[4],dbuff[2];
  unsigned int nbytes,nbytes0;
  int i,iflag,idata;
  FILE *fp0;
  double invfac;

  invfac=1.0e0/fac;
  if(open_file(&fp0,"tmp.bin","w+b")!=0)return(-1);
  if(copy_binary(fp,fp0)!=0)return(-1);  
  if(close_file(fp)!=0)return(-1);
  if(open_file(&fp,Fout,"w+b")!=0)return(-1);
  rewind(fp0);
  nbytes=2*ngridtot;
  nbytes=((nbytes+1)/2)*2;
  if(readwrite_dicom(fp0,fp)!=0)return(-1);
  for(i=0;i<Nloop;i++){
    if(get_tag(fp0,&group,&element)!=0)break;
    if(write_tag(fp,group,element)!=0)return(-1);
    if(find_tag(group,element,vr,name)!=0){
      strcpy(vr,"UN");
      strcpy(name,"Unknown");
    }
    if(get_bytes(fp0,vr,&nbytes0,&iflag,sbuff1,sbuff2)!=0)return(-1);
    if(group==ttag[42].group && element==ttag[42].element){
      set_bytes(nbytes,iflag,sbuff1,sbuff2);
      if(write_bytes(fp,iflag,sbuff1,sbuff2)!=0)return(-1);
      break;
    }else{
      if(write_bytes(fp,iflag,sbuff1,sbuff2)!=0)return(-1);
      if(readwrite_buff(fp0,fp,nbytes0)!=0)return(-1);
    }
  }
  if(ifendian==1){ // File is written in Little Endian
    for(i=0;i<ngridtot;i++){
      idata=data[i]*invfac;
      dbuff[0]=idata%256;
      dbuff[1]=idata/256;
      if(fwrite(dbuff,sizeof(char),2,fp)!=2){
	printf(" ERROR:: Overwritting RT dose data %d-th\n",i);
	return(-1);
      }
    }
  }else{ // File is written in Big Endian
    for(i=0;i<ngridtot;i++){
      idata=data[i]*invfac;
      dbuff[0]=idata/256;
      dbuff[1]=idata%256;
      if(fwrite(dbuff,sizeof(char),2,fp)!=2){
	printf(" ERROR:: Overwritting DICOM data %d-th\n",i);
	return(-1);
      }
    }
  }
  close_file(fp0);
  if(remove("tmp.bin")!=0){
    printf(" ERROR:: Fail to remove temporary file\n");
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int get_dicomheader(FILE *fp, struct TARGETTAG *p,
		    unsigned int *nbytes, char *buff)
{
  unsigned short group,element;
  char vr[3],name[128];
  unsigned char sbuff1[4],sbuff2[4];
  int i,iflag;
  if(check_dicom(fp)!=0){
    printf(" ERROR:: File is not DICOM format\n");
    printf(" File: %s\n",cfname);
    exit(-1);
  }
  for(i=0;i<Nloop;i++){
    if(get_tag(fp,&group,&element)!=0)break;
    if(find_tag(group,element,vr,name)!=0){
      strcpy(vr,"UN");
      strcpy(name,"Unknown");
    }
    if(get_bytes(fp,vr,nbytes,&iflag,sbuff1,sbuff2)!=0){
      printf(" ERROR:: Reading DICOM header VR\n");
      printf(" group=%04x element=%04x\n",group,element);
      printf(" File: %s\n",cfname);
      exit(-1);
    }
    if(get_buff(fp,*nbytes,buff)!=0){
      printf(" ERROR:: Reading DICOM header %d bytes\n",*nbytes);
      printf(" group=%04x element=%04x\n",group,element);
      printf(" File: %s\n",cfname);
      exit(-1);
    }
    if(group==p->group && element==p->element){
      return(0);
    }
  }
  if(i>Nloop){
    printf(" ERROR:: more than Nloop headers\n");
    printf(" File: %s\n",cfname);
    exit(-1);
  }
  return(-1);
}
/*-------------------------------------------------------------------------*/
int get_dicomdata(FILE *fp, int ndata, int nalloc, float *data)
{
  unsigned short group,element;
  char vr[3],name[128];
  unsigned char sbuff1[4],sbuff2[4];
  unsigned int nbytes;
  int i,iflag;
  short hu2;
  int hu4;
  if(check_dicom(fp)!=0){
    printf(" ERROR:: File is not DICOM format\n");
    exit(-1);
  }
  for(i=0;i<Nloop;i++){
    if(get_tag(fp,&group,&element)!=0)break;
    if(find_tag(group,element,vr,name)!=0){
      strcpy(vr,"UN");
      strcpy(name,"Unknown");
    }
    if(get_bytes(fp,vr,&nbytes,&iflag,sbuff1,sbuff2)!=0){
      printf(" ERROR:: Reading DICOM header VR\n");
      printf(" group=%04x element=%04x\n",group,element);
      exit(-1);
    }
    if(group==ttag[42].group && element==ttag[42].element){
      if(nbytes!=ndata*nalloc/8){
	printf(" ERROR:: Data size mismatch\n");
	printf(" group=%04x element=%04x\n",group,element);
	printf(" expected = %d\n",ndata);
	printf(" found    = %d\n",nbytes/nalloc*8);
	return(-1);
      }
      break;
    }
    if(get_buff(fp,nbytes,cbuff)!=0){
      printf(" ERROR:: Reading DICOM header %d bytes\n",nbytes);
      printf(" group=%04x element=%04x\n",group,element);
      exit(-1);
    }
  }
  if(i>Nloop){
    printf(" ERROR:: more than Nloop headers\n");
    exit(-1);
  }
  switch(nalloc){
  case 16:
    for(i=0;i<ndata;i++){
      if(fread(&hu2,sizeof(short),1,fp)==0){

	printf("fail to read %d\n",i);

	return(i+1);
      }
      if(imatch!=0)hu2=BS_INT16(hu2);
      data[i]=hu2;
    }
    break;
  case 32:
    for(i=0;i<ndata;i++){
      if(fread(&hu4,sizeof(int),1,fp)==0)return(i+1);
      if(imatch!=0)hu4=BS_INT32(hu4);
      data[i]=hu4;
    }
    break;
  default:
    printf(" ERROR:: Value of nalloc is %d and not 16 or 32\n",nalloc);
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int get_sloc(char *fname, double *sloc)
{
  FILE *fp;
  if(open_file(&fp,fname,"rb")!=0){
    printf(" ERROR:: Openning DICOM file: %s\n",fname);
    exit(-1);
  }
  if(check_file(fp,"CT")!=0)return(-1);
  if(get_DS(fp,&ttag[27],sloc)!=0){
    printf(" ERROR:: Reading Slice Location in DICOM file: %s\n",fname);
    exit(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int get_cshort(FILE *fp, struct TARGETTAG *p, char *cshort)
{
  unsigned int nbytes;
  int ierr;
  ierr=get_dicomheader(fp,p,&nbytes,cbuff);
  if(ierr==0){
    if(nbytes>256)nbytes=256;
    memset(cshort,0,256);
    strncpy(cshort,cbuff,nbytes);
  }
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int get_IS(FILE *fp, struct TARGETTAG *p, int *idata)
{
  unsigned int nbytes;
  int ierr;
  ierr=get_dicomheader(fp,p,&nbytes,cbuff);
  if(ierr==0){
    *idata=atoi(cbuff);
  }
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int get_US(FILE *fp,struct TARGETTAG *p,int *idata)
{
  unsigned int nbytes;
  unsigned short data;
  int ierr;
  ierr=get_dicomheader(fp,p,&nbytes,cbuff);
  if(ierr==0){
    if(ifendian==1){
      data=(short)((cbuff[0]&0xff)|((cbuff[1]<<8)&0xff00));
    }else{
      data=(short)((cbuff[1]&0xff)|((cbuff[0]<<8)&0xff00));
    }
    *idata=data;
  }
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int get_DS(FILE *fp, struct TARGETTAG *p,double *data)
{
  unsigned int nbytes;
  int ierr;
  ierr=get_dicomheader(fp,p,&nbytes,cbuff);
  if(ierr==0){
    *data=atof(cbuff);
  }
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int get_DS2(FILE *fp, struct TARGETTAG *p, double *data1, double *data2)
{
  char *sbuff;
  unsigned int nbytes;
  int ierr;
  ierr=get_dicomheader(fp,p,&nbytes,cbuff);
  if(ierr==0){
    *data1=strtod(cbuff,&sbuff);
    *data2=atof(sbuff+1);
  }
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int get_DS3(FILE *fp, struct TARGETTAG *p, double *data)
{
  char *sbuff;
  unsigned int nbytes;
  int ierr;
  ierr=get_dicomheader(fp,p,&nbytes,cbuff);
  if(ierr==0){
    data[0]=strtod(cbuff,&sbuff);
    data[1]=strtod(sbuff+1,&sbuff);
    data[2]=atof(sbuff+1);
  }
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int get_DS6(FILE *fp, struct TARGETTAG *p, double *data1, double *data2)
{
  char *sbuff;
  unsigned int nbytes;
  int ierr;
  ierr=get_dicomheader(fp,p,&nbytes,cbuff);
  if(ierr==0){
    data1[0]=strtod(cbuff,&sbuff);
    data1[1]=strtod(sbuff+1,&sbuff);
    data1[2]=strtod(sbuff+1,&sbuff);
    data2[0]=strtod(sbuff+1,&sbuff);
    data2[1]=strtod(sbuff+1,&sbuff);
    data2[2]=atof(sbuff+1);
  }
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int get_DSseq(FILE *fp, struct TARGETTAG *p,unsigned int *nbytes, char *buff)
{
  int ierr;
  ierr=get_dicomheader(fp,p,nbytes,buff);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int overwrite_dicomheader(FILE *fp, struct TARGETTAG *p, 
			  unsigned int nbytes, char *buff)
{
  unsigned short group,element;
  char vr[3],name[128];
  unsigned char sbuff1[4],sbuff2[4];
  unsigned int nbytes0;
  int i,iflag,jflag;
  FILE *fp0;
  if(open_file(&fp0,"tmp.bin","w+b")!=0)return(-1);
  if(copy_binary(fp,fp0)!=0)return(-1);
  if(close_file(fp)!=0)return(-1);
  if(open_file(&fp,Fout,"w+b")!=0)return(-1);
  rewind(fp0);
  jflag=0;
  if(readwrite_dicom(fp0,fp)!=0)return(-1);
  for(i=0;i<Nloop;i++){
    if(get_tag(fp0,&group,&element)!=0)break;
    if(write_tag(fp,group,element)!=0)return(-1);
    if(find_tag(group,element,vr,name)!=0){
      strcpy(vr,"UN");
      strcpy(name,"Unknown");
    }
    if(get_bytes(fp0,vr,&nbytes0,&iflag,sbuff1,sbuff2)!=0){
      printf(" ERROR:: Reading DICOM header VR\n");
      printf(" group=%04x element=%04x\n",group,element);
      printf(" File: %s\n",cfname);
      return(-1);
    }
    if(group==p->group && element==p->element){
      set_bytes(nbytes,iflag,sbuff1,sbuff2);
      if(write_bytes(fp,iflag,sbuff1,sbuff2)!=0)return(-1);
      if(get_buff(fp0,nbytes0,cbuff)!=0){
	printf(" ERROR:: Reading DICOM header %d bytes\n",nbytes);
	printf(" group=%04x element=%04x\n",group,element);
	printf("   %s\n",p->name);
	printf(" File: %s\n",cfname);
	return(-1);
      }
      if(write_buff(fp,nbytes,buff)!=0)return(-1);
      jflag=1;
    }else{
      if(write_bytes(fp,iflag,sbuff1,sbuff2)!=0)return(-1);
      if(readwrite_buff(fp0,fp,nbytes0)!=0)return(-1);
    }
  }
  if(i>999){
    printf(" ERROR:: more than Nloop headers\n");
    printf(" File: %s\n",cfname);
    return(-1);
  }
  if(jflag==0){
    printf(" ERROR:: dicom tag is missing\n");
    printf(" group=%04x element=%04x\n",p->group,p->element);
    printf("   %s\n",p->name);
    printf(" File: %s\n",cfname);
    return(-1);
  }
  close_file(fp0);
  if(remove("tmp.bin")!=0){
    printf(" ERROR:: Fail to remove temporary file\n");
    return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int write_tag(FILE *fp,unsigned short group,unsigned short element)
{
  if(fwrite(&group,sizeof(short),1,fp)<1)return(-1);
  if(fwrite(&element,sizeof(short),1,fp)<1)return(-1);
  return(0);
}
/*-------------------------------------------------------------------------*/
int write_bytes(FILE *fp,int iflag,
		unsigned char *sbuff1, unsigned char *sbuff2)
{
  if(fwrite(sbuff1,sizeof(char),4,fp)<4)return(-1);
  if(iflag==1){
    if(fwrite(sbuff2,sizeof(char),4,fp)<4)return(-1);
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
void set_bytes(unsigned int nbytes,int iflag,
		unsigned char *sbuff1, unsigned char *sbuff2)
{
  if(iflag==0){
    if(isupper(sbuff1[0]) && isupper(sbuff1[1])){
      if(ifendian==1){ // File is written in Little Endian
	sbuff1[2]=nbytes%256;
	sbuff1[3]=nbytes/256;
      }else{ // File is written in Big Endian
	sbuff1[2]=nbytes/256;
	sbuff1[3]=nbytes%256;
      }
    }else{
      if(ifendian==1){ // File is written in Little Endian
	sbuff1[0]=nbytes%256;
	sbuff1[3]=nbytes/(256*256*256);
	sbuff1[2]=(nbytes-sbuff2[3]*256*256*256)/(256*256);
	sbuff1[1]=(nbytes-sbuff2[3]*256*256*256-sbuff2[2]*256*256)/256;
      }else{ // File is written in Big Endian
	sbuff1[0]=nbytes/(256*256*256);
	sbuff1[1]=(nbytes-sbuff2[0]*256*256*256)/(256*256);
	sbuff1[2]=(nbytes-sbuff2[0]*256*256*256-sbuff2[1]*256*256)/256;
	sbuff1[3]=nbytes%256;
      }
    }      
  }else{
    if(ifendian==1){ // File is written in Little Endian
      sbuff2[0]=nbytes%256;
      sbuff2[3]=nbytes/(256*256*256);
      sbuff2[2]=(nbytes-sbuff2[3]*256*256*256)/(256*256);
      sbuff2[1]=(nbytes-sbuff2[3]*256*256*256-sbuff2[2]*256*256)/256;
    }else{ // File is written in Big Endian
      sbuff2[0]=nbytes/(256*256*256);
      sbuff2[1]=(nbytes-sbuff2[0]*256*256*256)/(256*256);
      sbuff2[2]=(nbytes-sbuff2[0]*256*256*256-sbuff2[1]*256*256)/256;
      sbuff2[3]=nbytes%256;
    }
  }
}
/*-------------------------------------------------------------------------*/
int write_buff(FILE *fp,unsigned int nbytes,char *buff)
{
  if(fwrite(buff,sizeof(char),nbytes,fp)<nbytes)return(-1);
  return(0);
}
/*-------------------------------------------------------------------------*/
int readwrite_buff(FILE *fp0,FILE *fp,unsigned int nbytes0)
{
  unsigned int nbytes,nrest;
  char buff[max_cb];
  nrest=nbytes0;
  while(nrest>0){
    nbytes=nrest;
    if(nbytes>max_cb)nbytes=max_cb;
    memset(buff,0,max_cb);
    if(fread(buff,sizeof(char),nbytes,fp0)!=nbytes)return(-1);
    if(fwrite(buff,sizeof(char),nbytes,fp)!=nbytes)return(-1);
    nrest=nrest-nbytes;
  }
  return(0);
}
/*-------------------------------------------------------------------------*/
int overwrite_cshort(FILE *fp, struct TARGETTAG *p, char *cshort)
{
  unsigned int nbytes;
  int ierr;
  nbytes=strlen(cshort);
  nbytes=((nbytes+1)/2)*2;
  ierr=overwrite_dicomheader(fp,p,nbytes,cshort);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int overwrite_IS(FILE *fp, struct TARGETTAG *p, int idata)
{
  unsigned int nbytes;
  char mbuff[256];
  int ierr;
  memset(mbuff,0,256);
  sprintf(mbuff,"%d",idata);
  nbytes=strlen(mbuff);
  nbytes=((nbytes+1)/2)*2;
  ierr=overwrite_dicomheader(fp,p,nbytes,mbuff);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int overwrite_US(FILE *fp, struct TARGETTAG *p, int idata)
{
  unsigned int nbytes;
  unsigned short data;
  char *mbuff;
  int ierr;
  data=(unsigned short)idata;
  if(imatch!=0)data=BS_INT16(data);
  mbuff=(char *)&data;
  nbytes=sizeof(short);
  ierr=overwrite_dicomheader(fp,p,nbytes,mbuff);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int overwrite_DS(FILE *fp, struct TARGETTAG *p, double data)
{
  unsigned int nbytes;
  char mbuff[256];
  int ierr;
  memset(mbuff,0,256);
  sprintf(mbuff,"%G",data);
  nbytes=strlen(mbuff);
  nbytes=((nbytes+1)/2)*2;
  ierr=overwrite_dicomheader(fp,p,nbytes,mbuff);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int overwrite_DS2(FILE *fp, struct TARGETTAG *p, double data1, double data2)
{
  unsigned int nbytes;
  char mbuff[256];
  int ierr;
  memset(mbuff,0,256);
  sprintf(mbuff,"%G\\%G ",data1,data2);
  nbytes=strlen(mbuff);
  nbytes=((nbytes+1)/2)*2;
  ierr=overwrite_dicomheader(fp,p,nbytes,mbuff);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int overwrite_DS3(FILE *fp, struct TARGETTAG *p,
		  double data1, double data2, double data3)
{
  unsigned int nbytes;
  char mbuff[256];
  int ierr;
  memset(mbuff,0,256);
  sprintf(mbuff,"%G\\%G\\%G ",data1,data2,data3);
  nbytes=strlen(mbuff);
  nbytes=((nbytes+1)/2)*2;
  ierr=overwrite_dicomheader(fp,p,nbytes,mbuff);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
int overwrite_DSseq(FILE *fp, struct TARGETTAG *p, int ngrid, double zdel)
{
  unsigned int nbytes;
  char mbuff[256],lbuff[max_cb];
  int i,ierr;
  double data;
  memset(lbuff,0,max_cb);
  data=0.0;
  sprintf(lbuff,"%G",data);
  for(i=1;i<ngrid;i++){
    memset(mbuff,0,256);
    data+=zdel;
    sprintf(mbuff,"\\%G",data);
    strcat(lbuff,mbuff);
  }
  nbytes=strlen(lbuff);
  nbytes=((nbytes+1)/2)*2;
  ierr=overwrite_dicomheader(fp,p,nbytes,lbuff);
  return(ierr);
}
/*-------------------------------------------------------------------------*/
void get_error(struct TARGETTAG *p)
{
  printf(" ERROR:: dicom tag is missing\n");
  printf(" Group=%04x Element=%04x\n",p->group,p->element);
  printf("   %s\n",p->name);
  exit(-1);
}
/*-------------------------------------------------------------------------*/
void get_warn(struct TARGETTAG *p)
{
  printf(" WARNING:: Dicom tag is missing\n");
  printf(" Group=%04x Element=%04x\n",p->group,p->element);
  printf("   %s\n",p->name);
  itagjump[p->num]=1;
}
