/***************************************************************************/
/*              C functions to read filenames in DICOM directory           */
/*                             for non-Windows (Mac and Linux)             */
/*                                                                         */
/*                  Created by T. Furuta on 2014/02/12                     */
/*                     Under collaboration between JAEA and RIKEN          */
/*                                                                         */
/*                  Last modified by T. Furuta on 2014/04/01               */
/*-------------------------------------------------------------------------*/
/*                  Main routine "dicom2phits.f" and                       */
/*                     c functions "dicomlib.c" are required               */
/***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include "dicomlib.h"
#include "utllib.h"
/********** Module variables ***********************************************/
extern int imendian;
/*-------------------------------------------------------------------------*/
void c_get_files_(int *nlist, char *path, long l){
  int i,j,ir;
  FILE *fp;
  char buff[200];
  double sloc;
  struct dirent **namelist;

  if((fp=fopen("tmp.txt","w"))==NULL){
    printf(" ERROR:: Openning temporary file: tmp.txt\n");
    exit(-1);
  }
  ir=scandir(path, &namelist, NULL, alphasort);
  if(ir == -1){
    printf(" ERROR:: Openning DICOM file directory: %s\n",path);
    exit(-1);
  }
  imendian=eval_imendian();
  j=0;
  for(i=0;i<ir;++i){
    if(strcmp(namelist[i]->d_name,".")&&strcmp(namelist[i]->d_name,"..")){
      memset(buff,0,200);
      strcpy(buff,path);
      strcat(buff,namelist[i]->d_name);
      if(get_sloc(buff,&sloc)==0){
	j++;
	fprintf(fp,"%s %lf\n",namelist[i]->d_name,sloc);
      }
    }
    free(namelist[i]);
  }
  free(namelist);
  *nlist=j;
  fclose(fp);

  return;
}
