/***************************************************************************/
/*              C functions to read filenames in DICOM directory           */
/*                             for windows                                 */
/*                                                                         */
/*                  Created by T. Furuta on 2014/02/12                     */
/*                     Under collaboration between JAEA and RIKEN          */
/*                                                                         */
/*                  Last modified by T. Furuta on 2014/04/01               */
/*-------------------------------------------------------------------------*/
/*                  Main routine "dicom2phits.f" and                       */
/*                     c functions "dicomlib.c" are required               */
/***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "dicomlib.h"
#include "utllib.h"
#define nline 200
/********** Module variables ***********************************************/
extern int imendian;
/*-------------------------------------------------------------------------*/
void c_get_files_(int *nlist, char *path, long l){
  int i;
  FILE *fp;
  char buff[nline],buff2[nline];
  char *star="*";
  double sloc;
  WIN32_FIND_DATA ffd;
  HANDLE h;

  if((fp=fopen("tmp.txt","w"))==NULL){
    printf(" ERROR:: Openning temporary file: tmp.txt\n");
    exit(-1);
  }
  imendian=eval_imendian();
  memset(buff2,0,nline);
  strcpy(buff2,path);
  strcat(buff2,star);
  h=FindFirstFile(buff2,&ffd);
  i=0;
  if(h!=INVALID_HANDLE_VALUE){
    do{
      if(strcmp(ffd.cFileName,".")&&strcmp(ffd.cFileName,"..")){
	memset(buff,0,nline);
	strcpy(buff,path);
	strcat(buff,ffd.cFileName);
	if(get_sloc(buff,&sloc)==0){
	  fprintf(fp,"%s %lf\n",ffd.cFileName,sloc);
	  i++;
	}
      }
    }while(FindNextFile(h,&ffd));
    FindClose(h);
  }else{
    printf(" ERROR:: Openning DICOM file directory: %s\n",path);
    exit(-1);
  }
  *nlist=i;
  fclose(fp);

  return;
}


